using System;
using System.Collections.Generic;

namespace Ato.EN.IntegrationServices.CodeGenerationIITR
{
    public class IITR2022
    {
    
    public string RPId = null;
    public bool RPExists = false;
    public int RPCount = 0;
    public int RPOccurrenceIndex = 0;
    public int RPLastOccurrenceIndex = 0;
    public string RPIdentifier = null;
    public string RPIdentifierScheme = null;
        public string RPIdentifierTFN = null;
        public DateTime? RPStartDate = null;
        public DateTime? RPEndDate = null;

        /// <summary>
        /// RP:tns:ContextPeriodStartDate
        /// </summary>
        public DateTime? IITR11 = null;

        /// <summary>
        /// RP:tns:ContextPeriodEndDate
        /// </summary>
        public DateTime? IITR12 = null;

        /// <summary>
        /// RP:tns:Identifiers.TaxFileNumber.Identifier
        /// </summary>
        public string IITR15 = null;

        /// <summary>
        /// RP:tns:Report.TargetFinancial.Year
        /// </summary>
        public int? IITR10 = null;

        /// <summary>
        /// RP:tns:IncomeTax.ReturnType.Code
        /// </summary>
        public string IITR13 = null;

        /// <summary>
        /// RP:tns:Report.Amendment.Indicator
        /// </summary>
        public bool? IITR16 = null;

        /// <summary>
        /// RP:tns:Report.AmendmentType.Code
        /// </summary>
        public string IITR17 = null;

        /// <summary>
        /// RP:tns:Report.AmendmentSequence.Number
        /// </summary>
        public decimal? IITR56 = null;

        /// <summary>
        /// RP:tns:Report.AmendmentReason.Text
        /// </summary>
        public string IITR18 = null;

        /// <summary>
        /// RP:tns:Residency.TaxPurposesPersonStatus.Indicator
        /// </summary>
        public bool? IITR19 = null;

        /// <summary>
        /// RP:tns:Residency.TaxPurposesStart.Date
        /// </summary>
        public DateTime? IITR666 = null;

        /// <summary>
        /// RP:tns:Residency.TaxPurposesEnd.Date
        /// </summary>
        public DateTime? IITR667 = null;

        /// <summary>
        /// RP:tns:PersonNameDetails.Title.Text
        /// </summary>
        public string IITR21 = null;

        /// <summary>
        /// RP:tns:PersonNameDetails.FamilyName.Text
        /// </summary>
        public string IITR22 = null;

        /// <summary>
        /// RP:tns:PersonNameDetails.NameSuffix.Text
        /// </summary>
        public string IITR23 = null;

        /// <summary>
        /// RP:tns:PersonNameDetails.GivenName.Text
        /// </summary>
        public string IITR24 = null;

        /// <summary>
        /// RP:tns:PersonNameDetails.OtherGivenName.Text
        /// </summary>
        public string IITR25 = null;

        /// <summary>
        /// RP:tns:Party.ChangeName.Indicator
        /// </summary>
        public bool? IITR26 = null;

        /// <summary>
        /// RP:tns:PersonDemographicDetails.Death.Date
        /// </summary>
        public DateTime? IITR28 = null;

        /// <summary>
        /// RP:tns:PersonDemographicDetails.Birth.Date
        /// </summary>
        public DateTime? IITR29 = null;

        /// <summary>
        /// RP:tns:Lodgment.FinalReturn.Indicator
        /// </summary>
        public bool? IITR30 = null;

        /// <summary>
        /// RP:tns:RegulatoryDisclosures.GeneralInformationAboutFinancialStatements.Text
        /// </summary>
        public string IITR31 = null;

        /// <summary>
        /// RP:tns:ElectronicContact.Telephone.Mobile.Number
        /// </summary>
        public string IITR48 = null;

        /// <summary>
        /// RP:tns:ElectronicContact.Telephone.Country.Code
        /// </summary>
        public string IITR579 = null;

        /// <summary>
        /// RP:tns:ElectronicContact.Telephone.Minimal.Number
        /// </summary>
        public string IITR50 = null;

        /// <summary>
        /// RP:tns:ElectronicContact.ElectronicMail.Address.Text
        /// </summary>
        public string IITR51 = null;

        /// <summary>
        /// RP:tns:FinancialInstitutionAccount.BankStateBranch.Number
        /// </summary>
        public string IITR53 = null;

        /// <summary>
        /// RP:tns:FinancialInstitutionAccount.FinancialInstitutionAccount.Number
        /// </summary>
        public string IITR54 = null;

        /// <summary>
        /// RP:tns:FinancialInstitutionAccount.FinancialInstitutionAccountName.Text
        /// </summary>
        public string IITR55 = null;

        /// <summary>
        /// RP:tns:PersonDemographicDetails.Occupation.Description
        /// </summary>
        public string IITR58 = null;

        /// <summary>
        /// RP:tns:PersonDemographicDetails.Occupation.Code
        /// </summary>
        public string IITR59 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldSalaryOrWages.Amount
        /// </summary>
        public decimal? IITR600 = null;

        /// <summary>
        /// RP:tns:Income.SalaryOrWages.Amount
        /// </summary>
        public decimal? IITR601 = null;

        /// <summary>
        /// RP:tns:Income.CommunityDevelopmentEmploymentProject.Amount
        /// </summary>
        public decimal? IITR602 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAllowancesEarningsTipsDirectorsFees.Amount
        /// </summary>
        public decimal? IITR64 = null;

        /// <summary>
        /// RP:tns:Income.AllowancesEarningsTipsDirectorsFees.Amount
        /// </summary>
        public decimal? IITR65 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldUnusedAnnualOrLongServiceLeavePaymentLumpSumA.Amount
        /// </summary>
        public decimal? IITR606 = null;

        /// <summary>
        /// RP:tns:Income.UnusedAnnualOrLongServiceLeavePaymentLumpSumA.Amount
        /// </summary>
        public decimal? IITR607 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldUnusedAnnualOrLongServiceLeavePaymentLumpSumB.Amount
        /// </summary>
        public decimal? IITR608 = null;

        /// <summary>
        /// RP:tns:Income.UnusedAnnualOrLongServiceLeavePaymentLumpSumB.Amount
        /// </summary>
        public decimal? IITR609 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldEmploymentTerminationPayment.Amount
        /// </summary>
        public decimal? IITR625 = null;

        /// <summary>
        /// RP:tns:Income.EmploymentTerminationPaymentTaxable.Amount
        /// </summary>
        public decimal? IITR626 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianGovernmentAllowancesAndPayments.Amount
        /// </summary>
        public decimal? IITR85 = null;

        /// <summary>
        /// RP:tns:Income.AustralianGovernmentAllowancesAndPayments.Amount
        /// </summary>
        public decimal? IITR86 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianGovernmentPensionsAndAllowances.Amount
        /// </summary>
        public decimal? IITR88 = null;

        /// <summary>
        /// RP:tns:Pension.Total.Amount
        /// </summary>
        public decimal? IITR89 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianAnnuitiesAndSuperannuationIncomeStream.Amount
        /// </summary>
        public decimal? IITR91 = null;

        /// <summary>
        /// RP:tns:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentTaxedElement.Amount
        /// </summary>
        public decimal? IITR92 = null;

        /// <summary>
        /// RP:tns:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentUntaxedElement.Amount
        /// </summary>
        public decimal? IITR93 = null;

        /// <summary>
        /// RP:tns:Income.Superannuation.AnnuitiesAndSuperannuationAssessableCappedBenefit.Amount
        /// </summary>
        public decimal? IITR505 = null;

        /// <summary>
        /// RP:tns:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentTaxedElement.Amount
        /// </summary>
        public decimal? IITR94 = null;

        /// <summary>
        /// RP:tns:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentUntaxedElement.Amount
        /// </summary>
        public decimal? IITR95 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldSuperannuationLumpSumPayment.Amount
        /// </summary>
        public decimal? IITR610 = null;

        /// <summary>
        /// RP:tns:Income.Superannuation.LumpSumPaymentTaxableComponentTaxedElement.Amount
        /// </summary>
        public decimal? IITR611 = null;

        /// <summary>
        /// RP:tns:Income.Superannuation.LumpSumPaymentTaxableComponentUntaxedElement.Amount
        /// </summary>
        public decimal? IITR612 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncome.Amount
        /// </summary>
        public decimal? IITR111 = null;

        /// <summary>
        /// RP:tns:Income.PersonalServicesIncome.Total.Amount
        /// </summary>
        public decimal? IITR112 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheld.Amount
        /// </summary>
        public decimal? IITR113 = null;

        /// <summary>
        /// RP:tns:Income.Interest.Gross.Amount
        /// </summary>
        public decimal? IITR115 = null;

        /// <summary>
        /// RP:tns:IncomeTax.TFNAmountsWithheldFromGrossInterest.Amount
        /// </summary>
        public decimal? IITR116 = null;

        /// <summary>
        /// RP:tns:Income.DividendsUnfranked.Amount
        /// </summary>
        public decimal? IITR118 = null;

        /// <summary>
        /// RP:tns:Income.DividendsFranked.Amount
        /// </summary>
        public decimal? IITR119 = null;

        /// <summary>
        /// RP:tns:IncomeTax.FrankingCredits.Amount
        /// </summary>
        public decimal? IITR120 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldDividendsTFNNotQuoted.Amount
        /// </summary>
        public decimal? IITR121 = null;

        /// <summary>
        /// RP:tns:Income.EmployeeShareScheme.TaxUpfrontReducibleDiscount.Amount
        /// </summary>
        public decimal? IITR123 = null;

        /// <summary>
        /// RP:tns:Income.EmployeeShareScheme.TaxUpfrontNonReducibleDiscount.Amount
        /// </summary>
        public decimal? IITR124 = null;

        /// <summary>
        /// RP:tns:Income.EmployeeShareScheme.DeferralDiscount.Amount
        /// </summary>
        public decimal? IITR125 = null;

        /// <summary>
        /// RP:tns:Income.EmployeeShareScheme.DiscountAssessable.Amount
        /// </summary>
        public decimal? IITR127 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldEmployeeShareSchemeDiscountTFNNotQuoted.Amount
        /// </summary>
        public decimal? IITR128 = null;

        /// <summary>
        /// RP:tns:Income.EmployeeShareScheme.ForeignSourceDiscount.Amount
        /// </summary>
        public decimal? IITR129 = null;

        /// <summary>
        /// RP:tns:Income.Net.Amount
        /// </summary>
        public decimal? IITR131 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.Car.Amount
        /// </summary>
        public decimal? IITR134 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.Travel.Amount
        /// </summary>
        public decimal? IITR136 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.Clothing.Amount
        /// </summary>
        public decimal? IITR137 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.EducationNet.Amount
        /// </summary>
        public decimal? IITR139 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.WorkRelatedOther.Amount
        /// </summary>
        public decimal? IITR141 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.LowValuePool.Amount
        /// </summary>
        public decimal? IITR145 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.Interest.Amount
        /// </summary>
        public decimal? IITR146 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.Dividend.Amount
        /// </summary>
        public decimal? IITR147 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.GiftDonation.Amount
        /// </summary>
        public decimal? IITR148 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.TaxAffairManagementATOInterest.Amount
        /// </summary>
        public decimal? IITR502 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.TaxAffairManagementLitigation.Amount
        /// </summary>
        public decimal? IITR503 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.TaxAffairManagementOther.Amount
        /// </summary>
        public decimal? IITR504 = null;

        /// <summary>
        /// RP:tns:Expense.DeductionsTotal.Amount
        /// </summary>
        public decimal? IITR150 = null;

        /// <summary>
        /// RP:tns:IncomeTax.LossesBroughtForwardPrimaryProduction.Amount
        /// </summary>
        public decimal? IITR153 = null;

        /// <summary>
        /// RP:tns:IncomeTax.LossesClaimedPrimaryProduction.Amount
        /// </summary>
        public decimal? IITR154 = null;

        /// <summary>
        /// RP:tns:IncomeTax.LossesBroughtForwardNonPrimaryProduction.Amount
        /// </summary>
        public decimal? IITR155 = null;

        /// <summary>
        /// RP:tns:IncomeTax.LossesClaimedNonPrimaryProduction.Amount
        /// </summary>
        public decimal? IITR156 = null;

        /// <summary>
        /// RP:tns:Income.Taxable.Amount
        /// </summary>
        public decimal? IITR157 = null;

        /// <summary>
        /// RP:tns:TaxOffsetClaim.SeniorAndPensioner.Code
        /// </summary>
        public string IITR163 = null;

        /// <summary>
        /// RP:tns:TaxOffsetClaim.Veteran.Code
        /// </summary>
        public string IITR164 = null;

        /// <summary>
        /// RP:tns:TaxOffsetClaim.SuperannuationIncomeStream.Amount
        /// </summary>
        public decimal? IITR166 = null;

        /// <summary>
        /// RP:tns:TaxOffsetClaim.Total.Amount
        /// </summary>
        public decimal? IITR168 = null;

        /// <summary>
        /// RP:tns:IncomeTax.MedicareLevy.DependentChildrenAndStudents.Count
        /// </summary>
        public decimal? IITR171 = null;

        /// <summary>
        /// RP:tns:IncomeTax.MedicareLevy.ExemptionFullDays.Count
        /// </summary>
        public decimal? IITR172 = null;

        /// <summary>
        /// RP:tns:IncomeTax.MedicareLevy.ExemptionFullDays.Code
        /// </summary>
        public string IITR173 = null;

        /// <summary>
        /// RP:tns:IncomeTax.MedicareLevy.ExemptionHalfDays.Count
        /// </summary>
        public decimal? IITR174 = null;

        /// <summary>
        /// RP:tns:IncomeTax.MedicareLevy.PrivateHospitalCoverWholePeriod.Indicator
        /// </summary>
        public bool? IITR176 = null;

        /// <summary>
        /// RP:tns:IncomeTax.MedicareLevy.SurchargeExemptionDays.Count
        /// </summary>
        public decimal? IITR177 = null;

        /// <summary>
        /// RP:tns:IncomeTax.ExceptedNetIncomeUnder18.Amount
        /// </summary>
        public decimal? IITR188 = null;

        /// <summary>
        /// RP:tns:IncomeTax.ExceptedIncomeUnder18.Code
        /// </summary>
        public string IITR189 = null;

        /// <summary>
        /// RP:tns:IncomeTax.ExceptedPrimaryProductionIncomeUnder18.Amount
        /// </summary>
        public decimal? IITR619 = null;

        /// <summary>
        /// RP:tns:IncomeTax.EligiblePrimaryProductionIncomeUnder18.Amount
        /// </summary>
        public decimal? IITR620 = null;

        /// <summary>
        /// RP:tns:IncomeTax.ExceptedNonPrimaryProductionIncomeUnder18.Amount
        /// </summary>
        public decimal? IITR621 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PartYearTaxFreeThresholdEligibleMonths.Number
        /// </summary>
        public decimal? IITR192 = null;

        /// <summary>
        /// RP:tns:IncomeTax.InvestmentPartnershipOtherSource.Amount
        /// </summary>
        public decimal? IITR194 = null;

        /// <summary>
        /// RP:tns:IncomeTax.EligiblePersonalSuperannuationContribution.Indicator
        /// </summary>
        public bool? IITR195 = null;

        /// <summary>
        /// RP:tns:IncomeTax.EmploymentBusinessOther.Amount
        /// </summary>
        public decimal? IITR196 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.BusinessOther.Amount
        /// </summary>
        public decimal? IITR197 = null;

        /// <summary>
        /// RP:tns:SuperannuationContribution.EmployerReportable.Amount
        /// </summary>
        public decimal? IITR201 = null;

        /// <summary>
        /// RP:tns:Pension.TaxFree.Amount
        /// </summary>
        public decimal? IITR202 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.ForeignIncomeTarget.Amount
        /// </summary>
        public decimal? IITR203 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.FinancialInvestmentNet.Amount
        /// </summary>
        public decimal? IITR204 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.RentalPropertyNet.Amount
        /// </summary>
        public decimal? IITR205 = null;

        /// <summary>
        /// RP:tns:ChildSupport.Payment.Amount
        /// </summary>
        public decimal? IITR206 = null;

        /// <summary>
        /// RP:tns:PersonDemographicDetails.DependentChildren.Count
        /// </summary>
        public decimal? IITR207 = null;

        /// <summary>
        /// RP:tns:Income.TaxableAdjusted.Amount
        /// </summary>
        public decimal? IITR208 = null;

        /// <summary>
        /// RP:tns:Income.Estimated.Amount
        /// </summary>
        public decimal? IITR209 = null;

        /// <summary>
        /// RP:tns:Income.LowIncomeSuperannuationContributionEligible.Amount
        /// </summary>
        public decimal? IITR210 = null;

        /// <summary>
        /// RP:tns:PersonDemographicDetails.SpouseFullYear.Indicator
        /// </summary>
        public bool? IITR220 = null;

        /// <summary>
        /// RP:tns:PersonDemographicDetails.SpouseRelationshipStart.Date
        /// </summary>
        public DateTime? IITR221 = null;

        /// <summary>
        /// RP:tns:PersonDemographicDetails.SpouseRelationshipEnd.Date
        /// </summary>
        public DateTime? IITR222 = null;

        /// <summary>
        /// RP:tns:Income.PartnershipPrimaryProductionShare.Amount
        /// </summary>
        public decimal? IITR242 = null;

        /// <summary>
        /// RP:tns:Income.TrustPrimaryProductionNetShare.Amount
        /// </summary>
        public decimal? IITR243 = null;

        /// <summary>
        /// RP:tns:Income.TrustPrimaryProductionNetShare.Code
        /// </summary>
        public string IITR244 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.PartnershipsAndTrustPrimaryProductionShare.Amount
        /// </summary>
        public decimal? IITR246 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.PartnershipsAndTrustPrimaryProductionShare.Code
        /// </summary>
        public string IITR247 = null;

        /// <summary>
        /// RP:tns:Income.PartnershipInvestmentLessForeignIncomeNonPrimaryProductionShare.Amount
        /// </summary>
        public decimal? IITR249 = null;

        /// <summary>
        /// RP:tns:Income.PartnershipRentalNonPrimaryProductionShare.Amount
        /// </summary>
        public decimal? IITR250 = null;

        /// <summary>
        /// RP:tns:Income.PartnershipNonPrimaryProductionOtherShare.Amount
        /// </summary>
        public decimal? IITR251 = null;

        /// <summary>
        /// RP:tns:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount
        /// </summary>
        public decimal? IITR252 = null;

        /// <summary>
        /// RP:tns:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Amount
        /// </summary>
        public decimal? IITR255 = null;

        /// <summary>
        /// RP:tns:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Code
        /// </summary>
        public string IITR256 = null;

        /// <summary>
        /// RP:tns:Income.TrustFrankedNonPrimaryProductionShare.Amount
        /// </summary>
        public decimal? IITR259 = null;

        /// <summary>
        /// RP:tns:Expense.LandcareOperationsNonPrimaryProduction.Amount
        /// </summary>
        public decimal? IITR260 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.TrustExcludingCapitalGainsAndForeignIncomeNonPrimaryProduction.Amount
        /// </summary>
        public decimal? IITR261 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.PartnershipExcludingForeignIncomeNonPrimaryProduction.Amount
        /// </summary>
        public decimal? IITR262 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.PartnershipRentalNonPrimaryProduction.Amount
        /// </summary>
        public decimal? IITR263 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.TrustsPartnershipsOtherAllowableNonPrimaryProduction.Amount
        /// </summary>
        public decimal? IITR264 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.TrustPartnershipOtherNonPrimaryProductionNet.Amount
        /// </summary>
        public decimal? IITR265 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.TrustPartnershipOtherNonPrimaryProductionNet.Code
        /// </summary>
        public string IITR266 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditForTaxWithheldWhereABNNotQuoted.Amount
        /// </summary>
        public decimal? IITR268 = null;

        /// <summary>
        /// RP:tns:IncomeTax.FrankingCreditsShare.Amount
        /// </summary>
        public decimal? IITR269 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditForTaxWithheldInvestmentsTFNNotQuotedShare.Amount
        /// </summary>
        public decimal? IITR270 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldCloselyHeldTrustShare.Amount
        /// </summary>
        public decimal? IITR271 = null;

        /// <summary>
        /// RP:tns:IncomeTax.CreditTrusteeTaxPaidShare.Amount
        /// </summary>
        public decimal? IITR272 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldForeignResidentShare.Amount
        /// </summary>
        public decimal? IITR273 = null;

        /// <summary>
        /// RP:tns:TaxOffsetClaim.NationalRentalAffordabilitySchemeEntitlementShare.Amount
        /// </summary>
        public decimal? IITR274 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeVoluntaryAgreement.Amount
        /// </summary>
        public decimal? IITR276 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeABNNotQuoted.Amount
        /// </summary>
        public decimal? IITR277 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeLabourHireOrOtherPayments.Amount
        /// </summary>
        public decimal? IITR278 = null;

        /// <summary>
        /// RP:tns:Income.PersonalServicesIncome.Net.Amount
        /// </summary>
        public decimal? IITR279 = null;

        /// <summary>
        /// RP:tns:Income.PrimaryProductionNet.Amount
        /// </summary>
        public decimal? IITR281 = null;

        /// <summary>
        /// RP:tns:Income.InvestmentNonPrimaryProductionNet.Amount
        /// </summary>
        public decimal? IITR282 = null;

        /// <summary>
        /// RP:tns:Income.RentalPropertyNonPrimaryProductionNet.Amount
        /// </summary>
        public decimal? IITR283 = null;

        /// <summary>
        /// RP:tns:Income.NonPrimaryProductionOtherNet.Amount
        /// </summary>
        public decimal? IITR284 = null;

        /// <summary>
        /// RP:tns:Income.NonPrimaryProductionNet.Amount
        /// </summary>
        public decimal? IITR285 = null;

        /// <summary>
        /// RP:tns:Income.SmallBusinessEntityNet.Amount
        /// </summary>
        public decimal? IITR557 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessVoluntaryAgreement.Amount
        /// </summary>
        public decimal? IITR286 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessABNNotQuoted.Amount
        /// </summary>
        public decimal? IITR287 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessForeignResident.Amount
        /// </summary>
        public decimal? IITR288 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessLabourHireOrOtherPayments.Amount
        /// </summary>
        public decimal? IITR289 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.DeferredNonCommercialPartnershipInvestmentShare.Amount
        /// </summary>
        public decimal? IITR291 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.DeferredNonCommercialPartnershipRentalShare.Amount
        /// </summary>
        public decimal? IITR292 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.DeferredNonCommercialPartnershipOtherShare.Amount
        /// </summary>
        public decimal? IITR293 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.DeferredNonCommercialPartnershipShare.Amount
        /// </summary>
        public decimal? IITR294 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.DeferredNonCommercialSoleTraderInvestment.Amount
        /// </summary>
        public decimal? IITR295 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.DeferredNonCommercialSoleTraderRental.Amount
        /// </summary>
        public decimal? IITR296 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.DeferredNonCommercialSoleTraderOther.Amount
        /// </summary>
        public decimal? IITR297 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.DeferredNonCommercialSoleTrader.Amount
        /// </summary>
        public decimal? IITR298 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.DeferredNonCommercialPrimaryProduction.Amount
        /// </summary>
        public decimal? IITR299 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.DeferredNonCommercialNonPrimaryProduction.Amount
        /// </summary>
        public decimal? IITR300 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.FarmManagementDeposits.Amount
        /// </summary>
        public decimal? IITR302 = null;

        /// <summary>
        /// RP:tns:Income.FarmManagementEarlyRepaymentsNaturalDisaster.Amount
        /// </summary>
        public decimal? IITR304 = null;

        /// <summary>
        /// RP:tns:Income.FarmManagementOtherRepayments.Amount
        /// </summary>
        public decimal? IITR305 = null;

        /// <summary>
        /// RP:tns:Income.FarmManagementDepositsOrRepaymentsNet.Amount
        /// </summary>
        public decimal? IITR306 = null;

        /// <summary>
        /// RP:tns:CapitalGainsTax.Event.Indicator
        /// </summary>
        public bool? IITR308 = null;

        /// <summary>
        /// RP:tns:CapitalGainsTax.ExemptionOrRolloverApplied.Indicator
        /// </summary>
        public bool? IITR309 = null;

        /// <summary>
        /// RP:tns:CapitalGainsTax.ExemptionOrRolloverApplied.Code
        /// </summary>
        public List<string> IITR310Collection = null;

        /// <summary>
        /// RP:tns:Capital.Gains.Net.Amount
        /// </summary>
        public decimal? IITR311 = null;

        /// <summary>
        /// RP:tns:Capital.Gains.Total.Amount
        /// </summary>
        public decimal? IITR312 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditForCapitalGainsWithheldFromForeignResidents.Amount
        /// </summary>
        public decimal? IITR497 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.DirectOrIndirectOverseasInterest.Indicator
        /// </summary>
        public bool? IITR315 = null;

        /// <summary>
        /// RP:tns:Income.ControlledForeignCompaniesAttributableIncome.Amount
        /// </summary>
        public decimal? IITR316 = null;

        /// <summary>
        /// RP:tns:Income.InternationalDealings.AttributedForeignIncomeForeignTrustorControlledForeignCompanyorTransferorTrust.Indicator
        /// </summary>
        public bool? IITR317 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.TransferorTrustAttributedForeignIncome.Amount
        /// </summary>
        public decimal? IITR318 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.ForeignIncomeGross.Amount
        /// </summary>
        public decimal? IITR320 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.ForeignEmploymentIncomeOther.Amount
        /// </summary>
        public decimal? IITR321 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.ForeignPensionOrAnnuityIncomeWithoutUndeductedPurchasePrice.Amount
        /// </summary>
        public decimal? IITR322 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.ForeignPensionOrAnnuityIncomeUndeductedPurchasePrice.Amount
        /// </summary>
        public decimal? IITR323 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.ForeignRent.Amount
        /// </summary>
        public decimal? IITR324 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.ForeignSourceCompanyIncomeOther.Amount
        /// </summary>
        public decimal? IITR325 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.ForeignSourceIncomeOther.Amount
        /// </summary>
        public decimal? IITR326 = null;

        /// <summary>
        /// RP:tns:Income.InternationalDealings.Net.Amount
        /// </summary>
        public decimal? IITR327 = null;

        /// <summary>
        /// RP:tns:IncomeTax.FrankingCreditsNewZealand.Amount
        /// </summary>
        public decimal? IITR328 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.ForeignEmploymentIncomePaymentSummary.Amount
        /// </summary>
        public decimal? IITR329 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.ExemptForeignEmploymentIncome.Amount
        /// </summary>
        public decimal? IITR330 = null;

        /// <summary>
        /// RP:tns:Income.InternationalDealings.TaxOffset.Amount
        /// </summary>
        public decimal? IITR331 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.AssetsLocatedOutsideAustralia.Indicator
        /// </summary>
        public bool? IITR332 = null;

        /// <summary>
        /// RP:tns:Income.RealEstateProperty.Rental.Amount
        /// </summary>
        public decimal? IITR334 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.RentalIncomeInterestDeductions.Amount
        /// </summary>
        public decimal? IITR335 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.CapitalWorksDeductions.Amount
        /// </summary>
        public decimal? IITR336 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.RentalIncomeDeductionsOtherThanInterestAndCapitalWorks.Amount
        /// </summary>
        public decimal? IITR337 = null;

        /// <summary>
        /// RP:tns:IncomeTax.LifeInsuranceCompaniesAndFriendlySocietiesBonuses.Amount
        /// </summary>
        public decimal? IITR339 = null;

        /// <summary>
        /// RP:tns:Income.ForestryManagedInvestmentScheme.Amount
        /// </summary>
        public decimal? IITR341 = null;

        /// <summary>
        /// RP:tns:Income.DepreciatingAssets.IntangibleBalancingAdjustment.Amount
        /// </summary>
        public decimal? IITR613 = null;

        /// <summary>
        /// RP:tns:Income.DepreciatingAssetsAssessableIncomeFromBalancingAdjustmentEventsTotal.Amount
        /// </summary>
        public decimal? IITR614 = null;

        /// <summary>
        /// RP:tns:IncomeTax.IncomeCategory1Other.Amount
        /// </summary>
        public decimal? IITR615 = null;

        /// <summary>
        /// RP:tns:IncomeTax.IncomeCategory2Total.Amount
        /// </summary>
        public decimal? IITR616 = null;

        /// <summary>
        /// RP:tns:IncomeTax.AssessableFirstHomeSuperSaverReleased.Amount
        /// </summary>
        public decimal? IITR650 = null;

        /// <summary>
        /// RP:tns:IncomeTax.AssessableFirstHomeSuperSaverReleasedTaxWithheld.Amount
        /// </summary>
        public decimal? IITR651 = null;

        /// <summary>
        /// RP:tns:IncomeTax.FinancialInvestmentsOther.Amount
        /// </summary>
        public decimal? IITR617 = null;

        /// <summary>
        /// RP:tns:IncomeTax.IncomeCategoryMiscellaneousOther.Amount
        /// </summary>
        public decimal? IITR618 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldLumpSumPaymentsInArrears.Amount
        /// </summary>
        public decimal? IITR354 = null;

        /// <summary>
        /// RP:tns:Income.SpecialProfessional.Amount
        /// </summary>
        public decimal? IITR355 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.ForeignPensionAnnuityIncomeUndeductedPurchasePrice.Amount
        /// </summary>
        public decimal? IITR358 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.ProjectPool.Amount
        /// </summary>
        public decimal? IITR366 = null;

        /// <summary>
        /// RP:tns:Expense.ForestryManagedInvestmentSchemeDeduction.Amount
        /// </summary>
        public decimal? IITR368 = null;

        /// <summary>
        /// RP:tns:SuperannuationContribution.SpouseContributions.Amount
        /// </summary>
        public decimal? IITR378 = null;

        /// <summary>
        /// RP:tns:TaxOffsetClaim.SuperannuationContributionSpouse.Amount
        /// </summary>
        public decimal? IITR379 = null;

        /// <summary>
        /// RP:tns:TaxOffsetClaim.ZoneOrOverseasForces.Amount
        /// </summary>
        public decimal? IITR381 = null;

        /// <summary>
        /// RP:tns:TaxOffsetClaim.DependentInvalidAndCarer.Amount
        /// </summary>
        public decimal? IITR386 = null;

        /// <summary>
        /// RP:tns:TaxOffsetClaim.LandcareAndWaterFacilityBroughtForward.Amount
        /// </summary>
        public decimal? IITR388 = null;

        /// <summary>
        /// RP:tns:IncomeTax.TaxOffsetRefundableOther.Amount
        /// </summary>
        public decimal? IITR395 = null;

        /// <summary>
        /// RP:tns:IncomeTax.TaxOffsetRefundableOther.Code
        /// </summary>
        public string IITR396 = null;

        /// <summary>
        /// RP:tns:IncomeTax.FamilyTrustDistributionWhereTaxPaid.Amount
        /// </summary>
        public decimal? IITR399 = null;

        /// <summary>
        /// RP:tns:Income.Interest.EarlyPaymentCredit.Amount
        /// </summary>
        public decimal? IITR401 = null;

        /// <summary>
        /// RP:tns:Income.PersonalServicesIncomeIncluded.Indicator
        /// </summary>
        public bool? IITR404 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PersonalServicesIncome.IndividualResultsTestSatisfied.Indicator
        /// </summary>
        public bool? IITR405 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PersonalServicesIncome.IndividualPersonalServiceBusinessDeterminationHeld.Indicator
        /// </summary>
        public bool? IITR406 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PersonalServicesIncome.OneSourceBenchmark.Indicator
        /// </summary>
        public bool? IITR407 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PersonalServicesIncome.UnrelatedClientsTestSatisfied.Indicator
        /// </summary>
        public bool? IITR408 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PersonalServicesIncome.EmploymentTestSatisfied.Indicator
        /// </summary>
        public bool? IITR409 = null;

        /// <summary>
        /// RP:tns:IncomeTax.PersonalServicesIncome.BusinessPremisesTestSatisfied.Indicator
        /// </summary>
        public bool? IITR410 = null;

        /// <summary>
        /// RP:tns:Income.PersonalServicesIncome.VoluntaryAgreement.Amount
        /// </summary>
        public decimal? IITR411 = null;

        /// <summary>
        /// RP:tns:Income.PersonalServicesIncome.ABNNotQuoted.Amount
        /// </summary>
        public decimal? IITR412 = null;

        /// <summary>
        /// RP:tns:Income.PersonalServicesIncome.LabourHireOrOtherSpecifiedPayment.Amount
        /// </summary>
        public decimal? IITR413 = null;

        /// <summary>
        /// RP:tns:Income.PersonalServicesIncome.Other.Amount
        /// </summary>
        public decimal? IITR414 = null;

        /// <summary>
        /// RP:tns:Expense.PersonalServicesIncome.PrincipalWorkPaymentsToAssociates.Amount
        /// </summary>
        public decimal? IITR415 = null;

        /// <summary>
        /// RP:tns:Expense.PersonalServicesIncome.OtherDeductionsTotal.Amount
        /// </summary>
        public decimal? IITR416 = null;

        /// <summary>
        /// RP:tns:OrganisationDetails.MainIncomeActivity.Description
        /// </summary>
        public string IITR418 = null;

        /// <summary>
        /// RP:tns:OrganisationDetails.OrganisationIndustry2006Extended.Code
        /// </summary>
        public string IITR419 = null;

        /// <summary>
        /// RP:tns:Income.PersonalServicesIncome.BusinessActivities.Count
        /// </summary>
        public decimal? IITR421 = null;

        /// <summary>
        /// RP:tns:OrganisationDetails.ActivityEvent.Code
        /// </summary>
        public string IITR423 = null;

        /// <summary>
        /// RP:tns:OrganisationNameDetails.OrganisationalName.Text
        /// </summary>
        public string IITR425 = null;

        /// <summary>
        /// RP:tns:Identifiers.AustralianBusinessNumber.Identifier
        /// </summary>
        public string IITR426 = null;

        /// <summary>
        /// RP:tns:Income.ABNNotQuotedPrimaryProductionPaymentGross.Amount
        /// </summary>
        public decimal? IITR436 = null;

        /// <summary>
        /// RP:tns:Income.ABNNotQuotedNonPrimaryProductionPaymentGross.Amount
        /// </summary>
        public decimal? IITR437 = null;

        /// <summary>
        /// RP:tns:Income.ForeignResidentWithholdingNonPrimaryProduction.Amount
        /// </summary>
        public decimal? IITR438 = null;

        /// <summary>
        /// RP:tns:Income.VoluntaryAgreementPrimaryProductionGross.Amount
        /// </summary>
        public decimal? IITR439 = null;

        /// <summary>
        /// RP:tns:Income.VoluntaryAgreementNonPrimaryProductionGross.Amount
        /// </summary>
        public decimal? IITR440 = null;

        /// <summary>
        /// RP:tns:Income.LabourHireArrangementPrimaryProductionPaymentGross.Amount
        /// </summary>
        public decimal? IITR441 = null;

        /// <summary>
        /// RP:tns:Income.LabourHireArrangementNonPrimaryProductionPaymentGross.Amount
        /// </summary>
        public decimal? IITR442 = null;

        /// <summary>
        /// RP:tns:Income.GovernmentIndustryPrimaryProductionPaymentsAssessable.Amount
        /// </summary>
        public decimal? IITR443 = null;

        /// <summary>
        /// RP:tns:Income.GovernmentIndustryPrimaryProductionPaymentsAssessable.Indicator
        /// </summary>
        public bool? IITR444 = null;

        /// <summary>
        /// RP:tns:Income.GovernmentIndustryNonPrimaryProductionPaymentsAssessable.Amount
        /// </summary>
        public decimal? IITR445 = null;

        /// <summary>
        /// RP:tns:Income.GovernmentIndustryNonPrimaryProductionPaymentsAssessable.Indicator
        /// </summary>
        public bool? IITR446 = null;

        /// <summary>
        /// RP:tns:Income.BusinessPrimaryProductionOther.Amount
        /// </summary>
        public decimal? IITR447 = null;

        /// <summary>
        /// RP:tns:Income.BusinessNonPrimaryProductionOther.Amount
        /// </summary>
        public decimal? IITR448 = null;

        /// <summary>
        /// RP:tns:Expense.Operating.MotorVehicleTypeOrClaimMethod.Code
        /// </summary>
        public string IITR464 = null;

        /// <summary>
        /// RP:tns:Expense.Operating.BusinessPrimaryProduction.Amount
        /// </summary>
        public decimal? IITR467 = null;

        /// <summary>
        /// RP:tns:Expense.Operating.BusinessNonPrimaryProduction.Amount
        /// </summary>
        public decimal? IITR468 = null;

        /// <summary>
        /// RP:tns:Income.BusinessPrimaryProductionNet.Amount
        /// </summary>
        public decimal? IITR474 = null;

        /// <summary>
        /// RP:tns:Income.BusinessNonPrimaryProductionNet.Amount
        /// </summary>
        public decimal? IITR475 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.BusinessDeferredNonCommercialLossPriorYearPrimaryProduction.Amount
        /// </summary>
        public decimal? IITR476 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.BusinessDeferredNonCommercialLossPriorYearNonPrimaryProduction.Amount
        /// </summary>
        public decimal? IITR477 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.LowCostAssetDepreciation.Amount
        /// </summary>
        public decimal? IITR507 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.SmallBusinessPoolDepreciation.Amount
        /// </summary>
        public decimal? IITR508 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.TemporaryFullExpensingEligibleAssetsOptOut.Code
        /// </summary>
        public string IITR590 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.TemporaryFullExpensingEligibleAssetsOptOut.Number
        /// </summary>
        public decimal? IITR591 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.TemporaryFullExpensingEligibleAssetsOptOut.Amount
        /// </summary>
        public decimal? IITR592 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.TemporaryFullExpensingEligibleAssets.Amount
        /// </summary>
        public decimal? IITR593 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.TemporaryFullExpensingEligibleAssets.Number
        /// </summary>
        public decimal? IITR594 = null;

        /// <summary>
        /// RP:tns:Remuneration.WagesAndSalaries.Total.Amount
        /// </summary>
        public decimal? IITR514 = null;

        /// <summary>
        /// RP:tns:Remuneration.WagesAndSalariesAction.Code
        /// </summary>
        public string IITR516 = null;

        /// <summary>
        /// RP:tns:Remuneration.PaymentToRelatedPartiesGross.Amount
        /// </summary>
        public decimal? IITR518 = null;

        /// <summary>
        /// RP:tns:Expense.DepreciatingAssets.IntangibleFirstDeducted.Amount
        /// </summary>
        public decimal? IITR520 = null;

        /// <summary>
        /// RP:tns:Expense.DepreciatingAssets.OtherFirstDeducted.Amount
        /// </summary>
        public decimal? IITR522 = null;

        /// <summary>
        /// RP:tns:Assets.DepreciatingAssets.IntangibleTerminationValue.Amount
        /// </summary>
        public decimal? IITR524 = null;

        /// <summary>
        /// RP:tns:Assets.DepreciatingAssets.OtherTerminationValue.Amount
        /// </summary>
        public decimal? IITR526 = null;

        /// <summary>
        /// RP:tns:Elections.TradingStock.Indicator
        /// </summary>
        public bool? IITR528 = null;

        /// <summary>
        /// RP:tns:Report.CompletionHours.Number
        /// </summary>
        public decimal? IITR530 = null;

        public string RPInstantId = null;
        public bool RPInstantExists = false;
        public int RPInstantCount = 0;
        public int RPInstantOccurrenceIndex = 0;
        public int RPInstantLastOccurrenceIndex = 0;
        public string RPInstantIdentifier = null;
        public string RPInstantIdentifierScheme = null;
        public string RPInstantIdentifierTFN = null;
        public DateTime? RPInstantInstantDate = null;

        /// <summary>
        /// RPInstant:tns:Capital.Losses.CarriedForward.Net.Amount
        /// </summary>
        public decimal? IITR313 = null;

        /// <summary>
        /// RPInstant:tns:Assets.Inventories.ValuationMethod.Code
        /// </summary>
        public string IITR453 = null;

        /// <summary>
        /// RPInstant:tns:Assets.TradeandReceivablesOther.Amount
        /// </summary>
        public decimal? IITR510 = null;

        /// <summary>
        /// RPInstant:tns:Liabilities.TradeAndOtherPayablesTotal.Amount
        /// </summary>
        public decimal? IITR512 = null;

        public string RPPOSId = null;
        public bool RPPOSExists = false;
        public int RPPOSCount = 0;
        public int RPPOSOccurrenceIndex = 0;
        public int RPPOSLastOccurrenceIndex = 0;
        public string RPPOSIdentifier = null;
        public string RPPOSIdentifierScheme = null;
        public string RPPOSIdentifierTFN = null;
        public DateTime? RPPOSStartDate = null;
        public DateTime? RPPOSEndDate = null;

        /// <summary>
        /// RPPOS:tns:AddressDetails.Line1.Text
        /// </summary>
        public string IITR33 = null;

        /// <summary>
        /// RPPOS:tns:AddressDetails.Line2.Text
        /// </summary>
        public string IITR34 = null;

        /// <summary>
        /// RPPOS:tns:AddressDetails.LocalityName.Text
        /// </summary>
        public string IITR35 = null;

        /// <summary>
        /// RPPOS:tns:AddressDetails.StateOrTerritory.Code
        /// </summary>
        public string IITR36 = null;

        /// <summary>
        /// RPPOS:tns:AddressDetails.Postcode.Text
        /// </summary>
        public string IITR37 = null;

        /// <summary>
        /// RPPOS:tns:AddressDetails.Country.Code
        /// </summary>
        public string IITR38 = null;

        /// <summary>
        /// RPPOS:tns:PersonDemographicDetails.AddressChange.Indicator
        /// </summary>
        public bool? IITR39 = null;

        public string RPRESId = null;
        public bool RPRESExists = false;
        public int RPRESCount = 0;
        public int RPRESOccurrenceIndex = 0;
        public int RPRESLastOccurrenceIndex = 0;
        public string RPRESIdentifier = null;
        public string RPRESIdentifierScheme = null;
        public string RPRESIdentifierTFN = null;
        public DateTime? RPRESStartDate = null;
        public DateTime? RPRESEndDate = null;

        /// <summary>
        /// RPRES:tns:AddressDetails.Line1.Text
        /// </summary>
        public string IITR41 = null;

        /// <summary>
        /// RPRES:tns:AddressDetails.Line2.Text
        /// </summary>
        public string IITR42 = null;

        /// <summary>
        /// RPRES:tns:AddressDetails.LocalityName.Text
        /// </summary>
        public string IITR43 = null;

        /// <summary>
        /// RPRES:tns:AddressDetails.StateOrTerritory.Code
        /// </summary>
        public string IITR44 = null;

        /// <summary>
        /// RPRES:tns:AddressDetails.Postcode.Text
        /// </summary>
        public string IITR45 = null;

        /// <summary>
        /// RPRES:tns:AddressDetails.Country.Code
        /// </summary>
        public string IITR52 = null;

        public string RPBUSId = null;
        public bool RPBUSExists = false;
        public int RPBUSCount = 0;
        public int RPBUSOccurrenceIndex = 0;
        public int RPBUSLastOccurrenceIndex = 0;
        public string RPBUSIdentifier = null;
        public string RPBUSIdentifierScheme = null;
        public string RPBUSIdentifierTFN = null;
        public DateTime? RPBUSStartDate = null;
        public DateTime? RPBUSEndDate = null;

        /// <summary>
        /// RPBUS:tns:AddressDetails.Line1.Text
        /// </summary>
        public string IITR428 = null;

        /// <summary>
        /// RPBUS:tns:AddressDetails.Line2.Text
        /// </summary>
        public string IITR429 = null;

        /// <summary>
        /// RPBUS:tns:AddressDetails.LocalityName.Text
        /// </summary>
        public string IITR430 = null;

        /// <summary>
        /// RPBUS:tns:AddressDetails.StateOrTerritory.Code
        /// </summary>
        public string IITR431 = null;

        /// <summary>
        /// RPBUS:tns:AddressDetails.Postcode.Text
        /// </summary>
        public string IITR432 = null;

        public string RPEligibleId = null;
        public bool RPEligibleExists = false;
        public int RPEligibleCount = 0;
        public int RPEligibleOccurrenceIndex = 0;
        public int RPEligibleLastOccurrenceIndex = 0;
        public string RPEligibleIdentifier = null;
        public string RPEligibleIdentifierScheme = null;
        public string RPEligibleIdentifierTFN = null;
        public DateTime? RPEligibleStartDate = null;
        public DateTime? RPEligibleEndDate = null;

        /// <summary>
        /// RPEligible:tns:Income.FringeBenefitsReportable.Amount
        /// </summary>
        public decimal? IITR490 = null;

        public string RPIneligibleId = null;
        public bool RPIneligibleExists = false;
        public int RPIneligibleCount = 0;
        public int RPIneligibleOccurrenceIndex = 0;
        public int RPIneligibleLastOccurrenceIndex = 0;
        public string RPIneligibleIdentifier = null;
        public string RPIneligibleIdentifierScheme = null;
        public string RPIneligibleIdentifierTFN = null;
        public DateTime? RPIneligibleStartDate = null;
        public DateTime? RPIneligibleEndDate = null;

        /// <summary>
        /// RPIneligible:tns:Income.FringeBenefitsReportable.Amount
        /// </summary>
        public decimal? IITR491 = null;

        public string RPJFOREIGNId = null;
        public bool RPJFOREIGNExists = false;
        public int RPJFOREIGNCount = 0;
        public int RPJFOREIGNOccurrenceIndex = 0;
        public int RPJFOREIGNLastOccurrenceIndex = 0;
        public string RPJFOREIGNIdentifier = null;
        public string RPJFOREIGNIdentifierScheme = null;
        public string RPJFOREIGNIdentifierTFN = null;
        public DateTime? RPJFOREIGNStartDate = null;
        public DateTime? RPJFOREIGNEndDate = null;

        /// <summary>
        /// RPJFOREIGN:tns:Income.Net.Amount
        /// </summary>
        public decimal? IITR494 = null;

        public string RPSPOUSEId = null;
        public bool RPSPOUSEExists = false;
        public int RPSPOUSECount = 0;
        public int RPSPOUSEOccurrenceIndex = 0;
        public int RPSPOUSELastOccurrenceIndex = 0;
        public string RPSPOUSEIdentifier = null;
        public string RPSPOUSEIdentifierScheme = null;
        public string RPSPOUSEIdentifierTFN = null;
        public DateTime? RPSPOUSEStartDate = null;
        public DateTime? RPSPOUSEEndDate = null;

        /// <summary>
        /// RPSPOUSE:tns:PersonNameDetails.FamilyName.Text
        /// </summary>
        public string IITR213 = null;

        /// <summary>
        /// RPSPOUSE:tns:PersonNameDetails.GivenName.Text
        /// </summary>
        public string IITR214 = null;

        /// <summary>
        /// RPSPOUSE:tns:PersonNameDetails.OtherGivenName.Text
        /// </summary>
        public string IITR215 = null;

        /// <summary>
        /// RPSPOUSE:tns:PersonDemographicDetails.Birth.Date
        /// </summary>
        public DateTime? IITR217 = null;

        /// <summary>
        /// RPSPOUSE:tns:PersonDemographicDetails.Sex.Code
        /// </summary>
        public string IITR218 = null;

        /// <summary>
        /// RPSPOUSE:tns:PersonDemographicDetails.Deceased.Indicator
        /// </summary>
        public bool? IITR223 = null;

        /// <summary>
        /// RPSPOUSE:tns:Income.Taxable.Amount
        /// </summary>
        public decimal? IITR225 = null;

        /// <summary>
        /// RPSPOUSE:tns:IncomeTax.TrustIncomeNotIncludedInTaxableIncome.Amount
        /// </summary>
        public decimal? IITR226 = null;

        /// <summary>
        /// RPSPOUSE:tns:IncomeTax.FamilyTrustDistributionWhereTaxPaid.Amount
        /// </summary>
        public decimal? IITR227 = null;

        /// <summary>
        /// RPSPOUSE:tns:Pension.Total.Amount
        /// </summary>
        public decimal? IITR229 = null;

        /// <summary>
        /// RPSPOUSE:tns:Pension.SpouseExempt.Amount
        /// </summary>
        public decimal? IITR230 = null;

        /// <summary>
        /// RPSPOUSE:tns:SuperannuationContribution.EmployerReportable.Amount
        /// </summary>
        public decimal? IITR231 = null;

        /// <summary>
        /// RPSPOUSE:tns:Pension.TaxFree.Amount
        /// </summary>
        public decimal? IITR232 = null;

        /// <summary>
        /// RPSPOUSE:tns:InternationalDealings.ForeignIncomeTarget.Amount
        /// </summary>
        public decimal? IITR233 = null;

        /// <summary>
        /// RPSPOUSE:tns:Tax.Losses.InvestmentNet.Amount
        /// </summary>
        public decimal? IITR234 = null;

        /// <summary>
        /// RPSPOUSE:tns:ChildSupport.Payment.Amount
        /// </summary>
        public decimal? IITR235 = null;

        /// <summary>
        /// RPSPOUSE:tns:SuperannuationPayment.BenefitLumpSumZeroTaxRate.Amount
        /// </summary>
        public decimal? IITR236 = null;

        /// <summary>
        /// RPSPOUSE:tns:Income.TaxableAdjusted.Amount
        /// </summary>
        public decimal? IITR237 = null;

        /// <summary>
        /// RPSPOUSE:tns:Identifiers.FamilyAssistanceOfficeCustomerReferenceNumber.Identifier
        /// </summary>
        public string IITR533 = null;

        public string RPSPOUSEEligibleId = null;
        public bool RPSPOUSEEligibleExists = false;
        public int RPSPOUSEEligibleCount = 0;
        public int RPSPOUSEEligibleOccurrenceIndex = 0;
        public int RPSPOUSEEligibleLastOccurrenceIndex = 0;
        public string RPSPOUSEEligibleIdentifier = null;
        public string RPSPOUSEEligibleIdentifierScheme = null;
        public string RPSPOUSEEligibleIdentifierTFN = null;
        public DateTime? RPSPOUSEEligibleStartDate = null;
        public DateTime? RPSPOUSEEligibleEndDate = null;

        /// <summary>
        /// RPSPOUSEEligible:tns:Income.FringeBenefitsReportable.Amount
        /// </summary>
        public decimal? IITR492 = null;

        public string RPSPOUSEIneligibleId = null;
        public bool RPSPOUSEIneligibleExists = false;
        public int RPSPOUSEIneligibleCount = 0;
        public int RPSPOUSEIneligibleOccurrenceIndex = 0;
        public int RPSPOUSEIneligibleLastOccurrenceIndex = 0;
        public string RPSPOUSEIneligibleIdentifier = null;
        public string RPSPOUSEIneligibleIdentifierScheme = null;
        public string RPSPOUSEIneligibleIdentifierTFN = null;
        public DateTime? RPSPOUSEIneligibleStartDate = null;
        public DateTime? RPSPOUSEIneligibleEndDate = null;

        /// <summary>
        /// RPSPOUSEIneligible:tns:Income.FringeBenefitsReportable.Amount
        /// </summary>
        public decimal? IITR493 = null;

        public string RPWHMId = null;
        public bool RPWHMExists = false;
        public int RPWHMCount = 0;
        public int RPWHMOccurrenceIndex = 0;
        public int RPWHMLastOccurrenceIndex = 0;
        public string RPWHMIdentifier = null;
        public string RPWHMIdentifierScheme = null;
        public string RPWHMIdentifierTFN = null;
        public DateTime? RPWHMStartDate = null;
        public DateTime? RPWHMEndDate = null;

        /// <summary>
        /// RPWHM:tns:Income.Net.Amount
        /// </summary>
        public decimal? IITR499 = null;

        /// <summary>
        /// RPWHM:tns:Remuneration.WorkingHolidayMakerGross.Amount
        /// </summary>
        public decimal? IITR622 = null;

        /// <summary>
        /// RPWHM:tns:IncomeTax.Deduction.WorkingHolidayMaker.Amount
        /// </summary>
        public decimal? IITR623 = null;

        /// <summary>
        /// RPWHM:tns:AddressDetails.Country.Code
        /// </summary>
        public string IITR624 = null;
        public List<RPPHISeqNumContext> RPPHISeqNumContextCollection = null;
        public class RPPHISeqNumContext
        {
    
            public string Id = null;
            public bool Exists = false;
            public int Count = 0;
            public int OccurrenceIndex = 0;
            public int LastOccurrenceIndex = 0;
            public string Identifier = null;
            public string IdentifierScheme = null;
            public string IdentifierTFN = null;
            public DateTime? StartDate = null;
            public DateTime? EndDate = null;

            public string PrivateHealthInsuranceSequenceDimensionValue = null;
    
            /// <summary>
            /// RPPHISeqNum:tns:Report.ItemOrder.Number
            /// </summary>
            public decimal? IITR570 = null;
    
            /// <summary>
            /// RPPHISeqNum:tns:Identifiers.HealthInsuranceProvider.Identifier
            /// </summary>
            public string IITR180 = null;
    
            /// <summary>
            /// RPPHISeqNum:tns:Identifiers.HealthInsuranceMembership.Identifier
            /// </summary>
            public string IITR181 = null;
    
            /// <summary>
            /// RPPHISeqNum:tns:IncomeTax.HealthInsurance.RebatableComponent.Amount
            /// </summary>
            public decimal? IITR182 = null;
    
            /// <summary>
            /// RPPHISeqNum:tns:IncomeTax.HealthInsurance.GovernmentRebateReceived.Amount
            /// </summary>
            public decimal? IITR183 = null;
    
            /// <summary>
            /// RPPHISeqNum:tns:IncomeTax.HealthInsurance.Benefit.Code
            /// </summary>
            public string IITR184 = null;
    
            /// <summary>
            /// RPPHISeqNum:tns:IncomeTax.HealthInsurance.TaxClaim.Code
            /// </summary>
            public string IITR185 = null;
        }
        public List<RPLOSSSeqNumContext> RPLOSSSeqNumContextCollection = null;
        public class RPLOSSSeqNumContext
        {
    
            public string Id = null;
            public bool Exists = false;
            public int Count = 0;
            public int OccurrenceIndex = 0;
            public int LastOccurrenceIndex = 0;
            public string Identifier = null;
            public string IdentifierScheme = null;
            public string IdentifierTFN = null;
            public DateTime? StartDate = null;
            public DateTime? EndDate = null;

            public string LossesSequenceDimensionValue = null;
    
            /// <summary>
            /// RPLOSSSeqNum:tns:Report.ItemOrder.Number
            /// </summary>
            public decimal? IITR573 = null;
    
            /// <summary>
            /// RPLOSSSeqNum:tns:OrganisationDetails.MainIncomeActivity.Description
            /// </summary>
            public string IITR479 = null;
    
            /// <summary>
            /// RPLOSSSeqNum:tns:OrganisationDetails.OrganisationIndustry2006Extended.Code
            /// </summary>
            public string IITR480 = null;
    
            /// <summary>
            /// RPLOSSSeqNum:tns:OrganisationDetails.OrganisationType.Code
            /// </summary>
            public string IITR481 = null;
    
            /// <summary>
            /// RPLOSSSeqNum:tns:IncomeTax.LossesType.Code
            /// </summary>
            public string IITR482 = null;
    
            /// <summary>
            /// RPLOSSSeqNum:tns:Tax.ProductRuling.Year
            /// </summary>
            public int? IITR488 = null;
    
            /// <summary>
            /// RPLOSSSeqNum:tns:Tax.ProductRulingNumber.Identifier
            /// </summary>
            public string IITR489 = null;
    
            /// <summary>
            /// RPLOSSSeqNum:tns:Tax.PrivateRulingNumber.Identifier
            /// </summary>
            public string IITR485 = null;
    
            /// <summary>
            /// RPLOSSSeqNum:tns:Tax.Losses.PriorYearNonCommercial.Amount
            /// </summary>
            public decimal? IITR486 = null;
    
            /// <summary>
            /// RPLOSSSeqNum:tns:Tax.Losses.Net.Amount
            /// </summary>
            public decimal? IITR487 = null;
        }

        public string RPPartnershipId = null;
        public bool RPPartnershipExists = false;
        public int RPPartnershipCount = 0;
        public int RPPartnershipOccurrenceIndex = 0;
        public int RPPartnershipLastOccurrenceIndex = 0;
        public string RPPartnershipIdentifier = null;
        public string RPPartnershipIdentifierScheme = null;
        public string RPPartnershipIdentifierTFN = null;
        public DateTime? RPPartnershipStartDate = null;
        public DateTime? RPPartnershipEndDate = null;

        /// <summary>
        /// RPPartnership:tns:Expense.LandcareOperationsAcceleratedDepreciation.Amount
        /// </summary>
        public decimal? IITR245 = null;

        /// <summary>
        /// RPPartnership:tns:Income.SmallBusinessEntityNet.Amount
        /// </summary>
        public decimal? IITR558 = null;

        public string RPTrustId = null;
        public bool RPTrustExists = false;
        public int RPTrustCount = 0;
        public int RPTrustOccurrenceIndex = 0;
        public int RPTrustLastOccurrenceIndex = 0;
        public string RPTrustIdentifier = null;
        public string RPTrustIdentifierScheme = null;
        public string RPTrustIdentifierTFN = null;
        public DateTime? RPTrustStartDate = null;
        public DateTime? RPTrustEndDate = null;

        /// <summary>
        /// RPTrust:tns:Income.SmallBusinessEntityNet.Amount
        /// </summary>
        public decimal? IITR559 = null;

        public string RPPrimId = null;
        public bool RPPrimExists = false;
        public int RPPrimCount = 0;
        public int RPPrimOccurrenceIndex = 0;
        public int RPPrimLastOccurrenceIndex = 0;
        public string RPPrimIdentifier = null;
        public string RPPrimIdentifierScheme = null;
        public string RPPrimIdentifierTFN = null;
        public DateTime? RPPrimStartDate = null;
        public DateTime? RPPrimEndDate = null;

        /// <summary>
        /// RPPrim:tns:Expense.Purchases.AndOtherCosts.Amount
        /// </summary>
        public decimal? IITR701 = null;

        /// <summary>
        /// RPPrim:tns:Expense.Operating.EmploymentCostsTotal.Amount
        /// </summary>
        public decimal? IITR703 = null;

        /// <summary>
        /// RPPrim:tns:SuperannuationContribution.EmployerContributions.Amount
        /// </summary>
        public decimal? IITR704 = null;

        /// <summary>
        /// RPPrim:tns:Expense.Operating.BadDebts.Amount
        /// </summary>
        public decimal? IITR705 = null;

        /// <summary>
        /// RPPrim:tns:Expense.Operating.Lease.Amount
        /// </summary>
        public decimal? IITR706 = null;

        /// <summary>
        /// RPPrim:tns:Expense.Operating.Rent.Amount
        /// </summary>
        public decimal? IITR707 = null;

        /// <summary>
        /// RPPrim:tns:Expense.Operating.InterestAustralia.Amount
        /// </summary>
        public decimal? IITR708 = null;

        /// <summary>
        /// RPPrim:tns:Expense.Operating.InterestForeign.Amount
        /// </summary>
        public decimal? IITR709 = null;

        /// <summary>
        /// RPPrim:tns:Expense.DepreciationandAmortisation.Amount
        /// </summary>
        public decimal? IITR710 = null;

        /// <summary>
        /// RPPrim:tns:Expense.Operating.MotorVehicle.Amount
        /// </summary>
        public decimal? IITR711 = null;

        /// <summary>
        /// RPPrim:tns:Expense.Operating.RepairsAndMaintenance.Amount
        /// </summary>
        public decimal? IITR712 = null;

        /// <summary>
        /// RPPrim:tns:Expense.Operating.Other.Amount
        /// </summary>
        public decimal? IITR713 = null;

        /// <summary>
        /// RPPrim:tns:Expense.CapitalExpenditureSpecifiedAllowableDeduction.Amount
        /// </summary>
        public decimal? IITR714 = null;

        /// <summary>
        /// RPPrim:tns:Expense.ProjectPoolAllowableDeduction.Amount
        /// </summary>
        public decimal? IITR715 = null;

        /// <summary>
        /// RPPrim:tns:Expense.LandcareOperationsAcceleratedDepreciation.Amount
        /// </summary>
        public decimal? IITR716 = null;

        /// <summary>
        /// RPPrim:tns:Income.ReconciliationAdjustmentTotal.Amount
        /// </summary>
        public decimal? IITR717 = null;

        /// <summary>
        /// RPPrim:tns:Expense.ReconciliationAdjustments.Amount
        /// </summary>
        public decimal? IITR718 = null;

        public string RPPrimInstantId = null;
        public bool RPPrimInstantExists = false;
        public int RPPrimInstantCount = 0;
        public int RPPrimInstantOccurrenceIndex = 0;
        public int RPPrimInstantLastOccurrenceIndex = 0;
        public string RPPrimInstantIdentifier = null;
        public string RPPrimInstantIdentifierScheme = null;
        public string RPPrimInstantIdentifierTFN = null;
        public DateTime? RPPrimInstantInstantDate = null;

        /// <summary>
        /// RPPrimInstant:tns:Assets.OpeningStock.Amount
        /// </summary>
        public decimal? IITR700 = null;

        /// <summary>
        /// RPPrimInstant:tns:Assets.ClosingStock.Amount
        /// </summary>
        public decimal? IITR702 = null;

        public string RPNonPrimId = null;
        public bool RPNonPrimExists = false;
        public int RPNonPrimCount = 0;
        public int RPNonPrimOccurrenceIndex = 0;
        public int RPNonPrimLastOccurrenceIndex = 0;
        public string RPNonPrimIdentifier = null;
        public string RPNonPrimIdentifierScheme = null;
        public string RPNonPrimIdentifierTFN = null;
        public DateTime? RPNonPrimStartDate = null;
        public DateTime? RPNonPrimEndDate = null;

        /// <summary>
        /// RPNonPrim:tns:Expense.Purchases.AndOtherCosts.Amount
        /// </summary>
        public decimal? IITR720 = null;

        /// <summary>
        /// RPNonPrim:tns:Expense.ForeignResidentWithholding.Amount
        /// </summary>
        public decimal? IITR722 = null;

        /// <summary>
        /// RPNonPrim:tns:Expense.Operating.EmploymentCostsTotal.Amount
        /// </summary>
        public decimal? IITR723 = null;

        /// <summary>
        /// RPNonPrim:tns:SuperannuationContribution.EmployerContributions.Amount
        /// </summary>
        public decimal? IITR724 = null;

        /// <summary>
        /// RPNonPrim:tns:Expense.Operating.BadDebts.Amount
        /// </summary>
        public decimal? IITR725 = null;

        /// <summary>
        /// RPNonPrim:tns:Expense.Operating.Lease.Amount
        /// </summary>
        public decimal? IITR726 = null;

        /// <summary>
        /// RPNonPrim:tns:Expense.Operating.Rent.Amount
        /// </summary>
        public decimal? IITR727 = null;

        /// <summary>
        /// RPNonPrim:tns:Expense.Operating.InterestAustralia.Amount
        /// </summary>
        public decimal? IITR728 = null;

        /// <summary>
        /// RPNonPrim:tns:Expense.Operating.InterestForeign.Amount
        /// </summary>
        public decimal? IITR729 = null;

        /// <summary>
        /// RPNonPrim:tns:Expense.DepreciationandAmortisation.Amount
        /// </summary>
        public decimal? IITR730 = null;

        /// <summary>
        /// RPNonPrim:tns:Expense.Operating.MotorVehicle.Amount
        /// </summary>
        public decimal? IITR731 = null;

        /// <summary>
        /// RPNonPrim:tns:Expense.Operating.RepairsAndMaintenance.Amount
        /// </summary>
        public decimal? IITR732 = null;

        /// <summary>
        /// RPNonPrim:tns:Expense.Operating.Other.Amount
        /// </summary>
        public decimal? IITR733 = null;

        /// <summary>
        /// RPNonPrim:tns:Expense.CapitalExpenditureSpecifiedAllowableDeduction.Amount
        /// </summary>
        public decimal? IITR734 = null;

        /// <summary>
        /// RPNonPrim:tns:Expense.ProjectPoolAllowableDeduction.Amount
        /// </summary>
        public decimal? IITR735 = null;

        /// <summary>
        /// RPNonPrim:tns:Expense.LandcareOperationsAcceleratedDepreciation.Amount
        /// </summary>
        public decimal? IITR736 = null;

        /// <summary>
        /// RPNonPrim:tns:Income.ReconciliationAdjustmentTotal.Amount
        /// </summary>
        public decimal? IITR737 = null;

        /// <summary>
        /// RPNonPrim:tns:Expense.ReconciliationAdjustments.Amount
        /// </summary>
        public decimal? IITR738 = null;

        public string RPNonPrimInstantId = null;
        public bool RPNonPrimInstantExists = false;
        public int RPNonPrimInstantCount = 0;
        public int RPNonPrimInstantOccurrenceIndex = 0;
        public int RPNonPrimInstantLastOccurrenceIndex = 0;
        public string RPNonPrimInstantIdentifier = null;
        public string RPNonPrimInstantIdentifierScheme = null;
        public string RPNonPrimInstantIdentifierTFN = null;
        public DateTime? RPNonPrimInstantInstantDate = null;

        /// <summary>
        /// RPNonPrimInstant:tns:Assets.OpeningStock.Amount
        /// </summary>
        public decimal? IITR719 = null;

        /// <summary>
        /// RPNonPrimInstant:tns:Assets.ClosingStock.Amount
        /// </summary>
        public decimal? IITR721 = null;

        public string RPInvestorId = null;
        public bool RPInvestorExists = false;
        public int RPInvestorCount = 0;
        public int RPInvestorOccurrenceIndex = 0;
        public int RPInvestorLastOccurrenceIndex = 0;
        public string RPInvestorIdentifier = null;
        public string RPInvestorIdentifierScheme = null;
        public string RPInvestorIdentifierTFN = null;
        public DateTime? RPInvestorStartDate = null;
        public DateTime? RPInvestorEndDate = null;

        /// <summary>
        /// RPInvestor:tns:TaxOffsetClaim.NonRefundableOther.Amount
        /// </summary>
        public decimal? IITR496 = null;

        public string RPInvestorYPreviousId = null;
        public bool RPInvestorYPreviousExists = false;
        public int RPInvestorYPreviousCount = 0;
        public int RPInvestorYPreviousOccurrenceIndex = 0;
        public int RPInvestorYPreviousLastOccurrenceIndex = 0;
        public string RPInvestorYPreviousIdentifier = null;
        public string RPInvestorYPreviousIdentifierScheme = null;
        public string RPInvestorYPreviousIdentifierTFN = null;
        public DateTime? RPInvestorYPreviousStartDate = null;
        public DateTime? RPInvestorYPreviousEndDate = null;

        /// <summary>
        /// RPInvestorYPrevious:tns:TaxOffsetClaim.NonRefundableOther.Amount
        /// </summary>
        public decimal? IITR501 = null;

        public string RPLimitedPartnersId = null;
        public bool RPLimitedPartnersExists = false;
        public int RPLimitedPartnersCount = 0;
        public int RPLimitedPartnersOccurrenceIndex = 0;
        public int RPLimitedPartnersLastOccurrenceIndex = 0;
        public string RPLimitedPartnersIdentifier = null;
        public string RPLimitedPartnersIdentifierScheme = null;
        public string RPLimitedPartnersIdentifierTFN = null;
        public DateTime? RPLimitedPartnersStartDate = null;
        public DateTime? RPLimitedPartnersEndDate = null;

        /// <summary>
        /// RPLimitedPartners:tns:TaxOffsetClaim.NonRefundableOther.Amount
        /// </summary>
        public decimal? IITR495 = null;

        public string RPLimitedPartnersYPreviousId = null;
        public bool RPLimitedPartnersYPreviousExists = false;
        public int RPLimitedPartnersYPreviousCount = 0;
        public int RPLimitedPartnersYPreviousOccurrenceIndex = 0;
        public int RPLimitedPartnersYPreviousLastOccurrenceIndex = 0;
        public string RPLimitedPartnersYPreviousIdentifier = null;
        public string RPLimitedPartnersYPreviousIdentifierScheme = null;
        public string RPLimitedPartnersYPreviousIdentifierTFN = null;
        public DateTime? RPLimitedPartnersYPreviousStartDate = null;
        public DateTime? RPLimitedPartnersYPreviousEndDate = null;

        /// <summary>
        /// RPLimitedPartnersYPrevious:tns:TaxOffsetClaim.NonRefundableOther.Amount
        /// </summary>
        public decimal? IITR500 = null;

        public string RPTrueAndCorrectId = null;
        public bool RPTrueAndCorrectExists = false;
        public int RPTrueAndCorrectCount = 0;
        public int RPTrueAndCorrectOccurrenceIndex = 0;
        public int RPTrueAndCorrectLastOccurrenceIndex = 0;
        public string RPTrueAndCorrectIdentifier = null;
        public string RPTrueAndCorrectIdentifierScheme = null;
        public string RPTrueAndCorrectIdentifierTFN = null;
        public DateTime? RPTrueAndCorrectStartDate = null;
        public DateTime? RPTrueAndCorrectEndDate = null;

        /// <summary>
        /// RPTrueAndCorrect:tns:Identifiers.TaxFileNumber.Identifier
        /// </summary>
        public string IITR549 = null;

        /// <summary>
        /// RPTrueAndCorrect:tns:PersonUnstructuredName.FullName.Text
        /// </summary>
        public string IITR550 = null;

        /// <summary>
        /// RPTrueAndCorrect:tns:PersonNameDetails.Position.Text
        /// </summary>
        public string IITR551 = null;

        /// <summary>
        /// RPTrueAndCorrect:tns:ElectronicContact.Telephone.Country.Code
        /// </summary>
        public string IITR580 = null;

        /// <summary>
        /// RPTrueAndCorrect:tns:ElectronicContact.Telephone.Minimal.Number
        /// </summary>
        public string IITR553 = null;

        /// <summary>
        /// RPTrueAndCorrect:tns:Declaration.Signature.Date
        /// </summary>
        public DateTime? IITR554 = null;

        /// <summary>
        /// RPTrueAndCorrect:tns:Declaration.StatementAccepted.Indicator
        /// </summary>
        public bool? IITR555 = null;

        /// <summary>
        /// RPTrueAndCorrect:tns:Declaration.SignatoryIdentifier.Text
        /// </summary>
        public string IITR556 = null;

        public string INTTrueAndCorrectId = null;
        public bool INTTrueAndCorrectExists = false;
        public int INTTrueAndCorrectCount = 0;
        public int INTTrueAndCorrectOccurrenceIndex = 0;
        public int INTTrueAndCorrectLastOccurrenceIndex = 0;
        public string INTTrueAndCorrectIdentifier = null;
        public string INTTrueAndCorrectIdentifierScheme = null;
        public string INTTrueAndCorrectIdentifierABN = null;
        public DateTime? INTTrueAndCorrectStartDate = null;
        public DateTime? INTTrueAndCorrectEndDate = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:Identifiers.AustralianBusinessNumber.Identifier
        /// </summary>
        public string IITR537 = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:PersonUnstructuredName.FullName.Text
        /// </summary>
        public string IITR538 = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:PersonNameDetails.Position.Text
        /// </summary>
        public string IITR539 = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:ElectronicContact.Telephone.Country.Code
        /// </summary>
        public string IITR581 = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:ElectronicContact.Telephone.Minimal.Number
        /// </summary>
        public string IITR541 = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:Declaration.Signature.Date
        /// </summary>
        public DateTime? IITR543 = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:Declaration.StatementAccepted.Indicator
        /// </summary>
        public bool? IITR544 = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:Declaration.SignatoryIdentifier.Text
        /// </summary>
        public string IITR545 = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:Identifiers.TaxAgentClientReference.Text
        /// </summary>
        public string IITR536 = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:Identifiers.TaxAgentNumber.Identifier
        /// </summary>
        public string IITR542 = null;

    }
}
