// ------------------------------------------------------------------------------
//  <auto-generated>
//     This code was generated from a template.
// 
//     Manual changes to this file will be overwritten if the code is regenerated.
//
//     Generated on 2018-02-14T11:01:05, by ESR Version 1.71.0.0 using ESR Database 
//  </auto-generated>
// ------------------------------------------------------------------------------

using System;
using System.IO;
using System.Runtime.CompilerServices;
using System.Text;
using System.Xml;
using System.Linq;
using System.Collections.Generic;
using DataContracts;
using System.Text.RegularExpressions;

namespace Ato.EN.IntegrationServices.CodeGenerationNRFI
{

    public partial class NRFI2018Validator
    {
        /// <summary>
        /// The max parameter name length is restricted by the SBR1 and SBR2 schemas - the lowest common denominator of SBR 1 is used as the default
        /// </summary>
        private int _maxParameterNameLength;

        /// <summary>
        /// The max parameter value length is restricted by the SBR1 and SBR2 schemas
        /// </summary>
        private int _maxParameterValueLength;

        /// <summary>
        /// The SBR1 and ebms3 schemas do not allow parameter names or values to be the empty string
        /// </summary>
        private string _emptyParameterValue;

        /// <summary>
        /// Initializes a new instance of the <see cref="NRFI2018Validator" /> class.
        /// </summary>
        /// <param name="maxParameterNameLength">Maximum length of the parameter name.</param>
        /// <param name="maxParameterValueLength">Maximum length of the parameter value.</param>
        /// <param name="emptyParameterValue">This value will be used in place of any parameter values that result in a null or empty value.</param>
        public NRFI2018Validator(int maxParameterNameLength = 20, int maxParameterValueLength = 4096, string emptyParameterValue = "EMPTY")
        {
            _maxParameterNameLength = maxParameterNameLength;
            _maxParameterValueLength = maxParameterValueLength;
            _emptyParameterValue = emptyParameterValue;
        }

        #region Functions
        private static IEnumerable<string> Union(IEnumerable<string> list1, IEnumerable<string> list2)
        {
            IEnumerable<string> response;

            if (list1 == null && list2 == null)
            {
                response = null;
            }
            else if (list1 == null)
            {
                response = list2.Distinct();
            }
            else if (list2 == null)
            {
                response = list1.Distinct();
            }
            else
            {
                response = list1.Union(list2);
            }

            return response;
        }

        private static bool IsMatch(int? field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(Convert.ToString(field.Value), expression, options);
        }

        private static bool IsMatch(string field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(field, expression, options);
        }

        // This is just context and tuple counts where they are integer values - easier that changing the parsing logic to just return the value
        private static int Count(int count)
        {
            return count;
        }


        private static int Count<T>(IEnumerable<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static int Count<T>(ICollection<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static bool exists(bool value)
        {
            return value;
        }

        private static string GetValueOrEmpty(bool? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        private static string GetValueOrEmpty(DateTime? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

         /// <summary>
         /// Get string value between [first] a and [last] b.
         /// </summary>
        public static string Between(string value, string a, string b)
        {
            int posA = value.IndexOf(a);
            int posB = value.LastIndexOf(b);
            if (posA == -1)
            {
                return "";
            }
            if (posB == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= posB)
            {
                return "";
            }
            return value.Substring(adjustedPosA, posB - adjustedPosA);
        }

         /// <summary>
         /// Get string value after [first] a.
         /// </summary>
        public static string Before(string value, string a)
        {
            int posA = value.IndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            return value.Substring(0, posA);
        }

         /// <summary>
         /// Get string value after [last] a.
         /// </summary>
        public static string After(string value, string a)
        {
            int posA = value.LastIndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= value.Length)
            {
                return "";
            }
            return value.Substring(adjustedPosA);
        }

        private static int Length(object field)
        {
            if (field == null)
            return 0;
            else
            return field.ToString().Trim().Length;
        }

        private static bool NotSameValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return NotSameValues(nodesArray);
        }

        private static bool NotSameValues(params object[] nodes)
        {
            if (nodes == null)
                return false;

            return ((from x in nodes select x).Distinct().Count() == nodes.Count());
        }

        private static bool HasDuplicateValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return HasDuplicateValues(nodesArray);
        }

        private static bool HasDuplicateValues(params object[] nodes)
        {
           if (nodes == null)
                return false;

            nodes = nodes.Where(x => x != null).ToArray();
            return !((from x in nodes select x).Distinct().Count() == nodes.Count());
        
        }

        private int DuplicateValueIndex(IEnumerable<object> values)
        {
            int response = 0;
            var hashset = new HashSet<object>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private int DuplicateValueIndex<T>(IEnumerable<T?> values) where T : struct
        {
            int response = 0;
            var hashset = new HashSet<T?>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private static bool IsDate(object value)
        {
            DateTime dateValue;
            return (value != null && DateTime.TryParse(value.ToString(), out dateValue));
        }

        public DateTime AsDate(string dateAsString)
        {
            DateTime response = DateTime.MinValue;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date;
            }

            return response;
        }
				//The logic in After function expects "---" for day and "--" for month. 
				//Since hyphen was missing the date always returned null
        public DateTime? ConvertToDate(int day, int month, int year)
        {
					return ConvertToDate(day == 0 ? null : "---" + day.ToString(), month == 0 ? null : "--" + month.ToString(), year == 0 ? null : year.ToString());
        }

        public DateTime? ConvertToDate(string day, string month, string year)
        {
            DateTime? response;
            DateTime result;

            if (year == null || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        public DateTime? ConvertToDate(string day, string month, int year)
        {
            DateTime? response;
            DateTime result;

            if (year == 0 || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year.ToString() + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        private static int Day(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Day;
            }

            return response;
        }


        private static int Day(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Day;

        }


        private static string Month(string dateAsString)
        {
            string response = null;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.ToString("MMMM");
            }
            else
            {
                return "NotAMonth";
            }

            return response;
        }

        private static string Month(DateTime? date)
        {
            if (date == null)
                return "NotAMonth";
            else
                return date.Value.ToString("MMMM");
        }


        private static int MonthAsInt(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Month;
            }

            return response;
        }

        private static int MonthAsInt(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            return date.Value.Month;
        }


        private static int Year(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Year;
            }

            return response;
        }

        private static int Year(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Year;
        }


        private static int CurrentFinancialYear()
        {
            return DateToFinancialYear(DateTime.Now, 7);
        }

        private static int FinancialYear(string dateAsString)
        {
            return DateToFinancialYear(dateAsString, 7);
        }

        private static int FinancialYear(DateTime? date)
        {
            return DateToFinancialYear(date, 7);
        }

        private static int DateToFinancialYear(string dateAsString, int startingMonth)
        {
            int response = 0;
            DateTime date;
            if (DateTime.TryParse(dateAsString, out date))
            {
                response = DateToFinancialYear(date, startingMonth);
            }

            return response;
        }
        private static int DateToFinancialYear(DateTime? date, int startingMonth)
        {
            int response;
            if (date == null)
            {
                response = 0;
            }
            else
            {
                int year = date.Value.Year;
                int month = date.Value.Month;

                if (startingMonth > month)
                    response = year;
                else
                    response = year + 1;
            }
            return response;
        }


        private static int FBTYear(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
                response = FBTYear(date);
            return response;
        }

        private static int FBTYear(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            else
            {
                if (date.Value.Month > 3)
                    return date.Value.Year + 1;
                else
                    return date.Value.Year;
            }
        }

        private static DateTime? AddMonthsToDate(DateTime? dateTime, int months)
        {
            return dateTime == null ? null : (DateTime?)dateTime.Value.AddMonths(months);
        }

        private static bool IsNumeric(object value)
        {
            decimal numbervalue;
            return (value != null && decimal.TryParse(value.ToString(), out numbervalue));
        }

        private static bool NotMonetary(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(int? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }

        private static bool NotNumeric(long? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }


        private static bool OutsideRange(decimal field, decimal expression, int range)
        {
            bool response;

            response = (field < (expression - range)) || (field > (expression + range));

            return response;
        }


        private static bool FailsUSIAlgorithm(string usi, string abn)
        {
            bool response = true;
            if (usi == null || abn == null)
            {
                response = false;
            }
            else
            {
                usi = usi.Trim();
                abn = abn.Trim();
                if (usi.Length == 14)
                {
                    int numeric;
                    if (usi.Substring(0, 11) == abn && int.TryParse(usi.Substring(11, 3), out numeric))
                        response = false;

                }
                else if (usi.Length == 9)
                {

                    if (Regex.IsMatch(usi, @"^([a-zA-Z]{3}\d{4}[a-zA-Z]{2})$"))
                        response = false;
                }
            }
            return response;
        }

        private static bool FailsTANAlgorithm(string tan)
        {
            bool response;
            decimal decimalTan;

            if (tan == null)
                return false;

            tan = tan.Trim();

            if (!decimal.TryParse(tan, out decimalTan))
                return true;

            if (tan.Length != 8)
                return true;

            decimal tanSum =
                7 * int.Parse(tan.Substring(0, 1)) +
                9 * int.Parse(tan.Substring(1, 1)) +
                8 * int.Parse(tan.Substring(2, 1)) +
                4 * int.Parse(tan.Substring(3, 1)) +
                6 * int.Parse(tan.Substring(4, 1)) +
                3 * int.Parse(tan.Substring(5, 1)) +
                5 * int.Parse(tan.Substring(6, 1)) +
                1 * int.Parse(tan.Substring(7, 1));

            if ((tanSum % 11) == 0)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsABNAlgorithm(string abn)
        {
            bool response;
            decimal decimalAbn;

            if (abn == null)
                return false;

            abn = abn.Trim();

            if (!decimal.TryParse(abn, out decimalAbn))
                return true;

            if (abn.Length != 11)
                return true;

            decimal abnSum =
                10 * (int.Parse(abn.Substring(0, 1)) - 1) +
                1 * int.Parse(abn.Substring(1, 1)) +
                3 * int.Parse(abn.Substring(2, 1)) +
                5 * int.Parse(abn.Substring(3, 1)) +
                7 * int.Parse(abn.Substring(4, 1)) +
                9 * int.Parse(abn.Substring(5, 1)) +
                11 * int.Parse(abn.Substring(6, 1)) +
                13 * int.Parse(abn.Substring(7, 1)) +
                15 * int.Parse(abn.Substring(8, 1)) +
                17 * int.Parse(abn.Substring(9, 1)) +
                19 * int.Parse(abn.Substring(10, 1));

            if ((abnSum % 89) == 0)
                response = false;
            else
                response = true;

            return response;
        }
        private static bool FailsACNAlgorithm(string acn)
        {
            bool response;
            decimal decimalAbn;
            if (acn == null)
                return false;

            acn = acn.Trim();

            if (!decimal.TryParse(acn, out decimalAbn))
                return true;

            if (acn.Length != 9)
                return true;

            decimal abnSum =
                8 * int.Parse(acn.Substring(0, 1)) +
                7 * int.Parse(acn.Substring(1, 1)) +
                6 * int.Parse(acn.Substring(2, 1)) +
                5 * int.Parse(acn.Substring(3, 1)) +
                4 * int.Parse(acn.Substring(4, 1)) +
                3 * int.Parse(acn.Substring(5, 1)) +
                2 * int.Parse(acn.Substring(6, 1)) +
                1 * int.Parse(acn.Substring(7, 1));

            decimal checkDigit = int.Parse(acn.Substring(8, 1));
            decimal acnRemainder = abnSum % 10;

            if (((10 - acnRemainder) % 10) == checkDigit)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsTFNAlgorithm(string tfn)
        {
            bool response;
            decimal decimalTfn;

            if (tfn == null)
                return false;

            tfn = tfn.Trim();
            tfn = Regex.Replace(tfn, "^0+", "");

            if (!decimal.TryParse(tfn, out decimalTfn))
                return true;

            if (tfn.Length < 8)
                return true;


            decimal tfn1To7Sum =
                1 * int.Parse(tfn.Substring(0, 1)) +
                4 * int.Parse(tfn.Substring(1, 1)) +
                3 * int.Parse(tfn.Substring(2, 1)) +
                7 * int.Parse(tfn.Substring(3, 1)) +
                5 * int.Parse(tfn.Substring(4, 1)) +
                8 * int.Parse(tfn.Substring(5, 1)) +
                6 * int.Parse(tfn.Substring(6, 1));

            decimal tfn8 = 9 * int.Parse(tfn.Substring(7, 1));

            if (tfn.Length == 8)
            {
                decimal tFNLg8WSum9 = 10 * int.Parse(tfn.Substring(7, 1));
                decimal tFNLg8WSum = tfn1To7Sum + tFNLg8WSum9;

                if ((tFNLg8WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else if (tfn.Length == 9)
            {
                decimal tfn9 = 10 * int.Parse(tfn.Substring(8, 1));
                decimal tFNLg9WSum = tfn1To7Sum + tfn8 + tfn9;

                if ((tFNLg9WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else
            {
                response = true;
            }

            return response;
        }


        private static decimal ConditionalValue(bool expression, decimal? trueVal, decimal? falseVal)
        {
             return expression ? trueVal.GetValueOrDefault() : falseVal.GetValueOrDefault();
        }

        private static decimal AsNumeric(string value)
        {
             decimal numberValue;
             decimal.TryParse(value, out numberValue);
             return numberValue;
        }

        private static bool RegexMatch(int? field, string expression, string flags="")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static bool RegexMatch(string field, string expression, string flags="")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static RegexOptions GetRegexOption(string flags)
        {
            RegexOptions options = RegexOptions.None;

            char[] characters = flags.ToCharArray();

            foreach (char character in characters)
            {
                switch (character)
                {
                    case 'i':                        
                        options = options | RegexOptions.IgnoreCase;                       
                        break;
                    case 'm':                        
                        options = options | RegexOptions.Multiline;                       
                        break;
                    case 's':                        
                            options = options | RegexOptions.Singleline;                       
                        break;
                    case 'n':                        
                            options = options | RegexOptions.ExplicitCapture;                       
                        break;
                    case 'x':                       
                            options = options | RegexOptions.IgnorePatternWhitespace;                       
                        break;
                }
            }

            return options;
        }

        /// <summary>
        /// Returns an occurrence index as [occurrenceIndex] of occurrenceIndex > 0, otherwise the empty string
        /// </summary>
        /// <param name="occurrenceIndex">Index of the occurrence.</param>
        /// <returns>Occurrence in XPath [#] format</returns>
        public string OccurrenceIndex(int occurrenceIndex)
        {
            return occurrenceIndex > 0 ? "[" + occurrenceIndex + "]" : "";
        }

        #endregion // Functions

        public NRFI2018 ConsumedReport { get; private set; }

        private static Dictionary<string, ProcessMessageDocument> _processMessageDocuments = new Dictionary<string,ProcessMessageDocument>();

        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        public List<ProcessMessageDocument> ValidateReport(NRFI2018 report)
        {

            List<ProcessMessageDocument> response = new List<ProcessMessageDocument>();
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            bool assertion;

            this.ConsumedReport = report;

            // ------------------------------------------------------------------------------
            // Validations are now done in code.
            // This version supports full validation of a report - for those rules that have successfully parsed and could be generated.
            // Generated Validations include:
            //   - Validation logic in C#.
            //   - Production of errors in EBMS, SBR and SWS format.
            // 
            // The generation at this stage does not support the following - and has to be completed manually (later versions of the generation will do this for you)
            //   - Business Rules that did not parse.  The ESR team will help support you where this happens as an effort is being made to rectify these
            //   - You will get TODO tasks for those that the parser could not cope with
            // ------------------------------------------------------------------------------

    
            #region VR.ATO.GEN.500075
    
            /*  VR.ATO.GEN.500075
            Entity identifier scheme for ReportingParty must be "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF (RP:entity.identifier.scheme <> "http://www.ato.gov.au/tfn")
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP
            */
            assertion = ((report.RPExists == true) && (report.RPIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.438029", Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for ReportingParty must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.GEN.500075"} },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500075
    
            #region VR.ATO.NRFI.100001
    
            /*  VR.ATO.NRFI.100001
            Invalid context. The number of Reporting party contexts must equal 1.
    
            Legacy Rule Format:
            IF COUNT(RP) <> 1
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) <> 1
    
            Data Elements:
    
            ^Context = RP
            */
            assertion = (Count(report.RPCount) != 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100001", Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting party contexts must equal 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100001"} },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100001
    
            #region VR.ATO.NRFI.100002
    
            /*  VR.ATO.NRFI.100002
            At least one Foreign income source country code must be provided
    
            Legacy Rule Format:
            IF COUNT([NRFI1]) = 0
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^NRFI1) = 0
    
            Data Elements:
    
            RP:^NRFI1 = tns:AddressDetails.Country.Code
            */
            assertion = (Count(report.NRFI1Collection) == 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100002", Severity = ProcessMessageSeverity.Error,
                    Description = @"At least one Foreign income source country code must be provided",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Country.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100002"} },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100002
    
            #region VR.ATO.NRFI.100003
    
            /*  VR.ATO.NRFI.100003
            Foreign income source country code must not be "Australia", "Christmas Island", "Norfolk Island" or "Cocos (Keeling) Islands"
    
            Legacy Rule Format:
            IF ANY OCCURRENCE OF([NRFI1]) = SET("au","cc","cx","nf")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            AnyOccurrence(^NRFI1, InSet(^NRFI1, '"au","cc","cx","nf"'))
    
            Data Elements:
    
            RP:^NRFI1 = tns:AddressDetails.Country.Code
            */
            assertion = (report.NRFI1Collection == null ? false : report.NRFI1Collection.Any(NRFI1Repeat => IsMatch(NRFI1Repeat, @"^(au|cc|cx|nf)$")));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100003", Severity = ProcessMessageSeverity.Error,
                    Description = @"Foreign income source country code must not be ""Australia"", ""Christmas Island"", ""Norfolk Island"" or ""Cocos (Keeling) Islands""",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Country.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100003"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI1", Value = "Count(NRFI1)" });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100003
    
            #region VR.ATO.NRFI.100004
    
            /*  VR.ATO.NRFI.100004
            Foreign occupation code is mandatory
    
            Legacy Rule Format:
            IF [NRFI2] = NULL
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^NRFI2 = NULL
    
            Data Elements:
    
            RP:^NRFI2 = tns:PersonDemographicDetails.Occupation.Code
            */
            assertion = (report.NRFI2 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.110004", Severity = ProcessMessageSeverity.Error,
                    Description = @"Foreign occupation code must be present",
                    LongDescription = @"Foreign occupation code must be present. Where the individual does not have an occupation, or a relevant occupation code is not available, enter '999000'.",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.Occupation.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100004"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI2", Value = report.NRFI2 });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100004
    
            #region VR.ATO.NRFI.100005
    
            /*  VR.ATO.NRFI.100005
            Foreign income assessment method is mandatory
    
            Legacy Rule Format:
            IF [NRFI3] = NULL
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^NRFI3 = NULL
    
            Data Elements:
    
            RP:^NRFI3 = tns:IncomeTax.NonResidentAssessment.Code
            */
            assertion = (report.NRFI3 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100005", Severity = ProcessMessageSeverity.Error,
                    Description = @"Foreign income assessment method must be present",
                    Location = "/xbrli:xbrl/tns:IncomeTax.NonResidentAssessment.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100005"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI3", Value = report.NRFI3 });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100005
    
            #region VR.ATO.NRFI.100006
    
            /*  VR.ATO.NRFI.100006
            When the Foreign income assessment method is "Comprehensive" then at least one income field amount must be provided
    
            Legacy Rule Format:
            IF [NRFI3] = "Comprehensive" AND ([NRFI11] = NULL AND [NRFI12] = NULL AND [NRFI13] = NULL AND [NRFI14] = NULL AND [NRFI15] = NULL AND [NRFI16] = NULL AND [NRFI17] = NULL AND [NRFI18] = NULL AND [NRFI19] = NULL AND [NRFI20] = NULL AND [NRFI21] = NULL AND [NRFI22] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^NRFI3 = 'Comprehensive' AND (^NRFI11 = NULL AND ^NRFI12 = NULL AND ^NRFI13 = NULL AND ^NRFI14 = NULL AND ^NRFI15 = NULL AND ^NRFI16 = NULL AND ^NRFI17 = NULL AND ^NRFI18 = NULL AND ^NRFI19 = NULL AND ^NRFI20 = NULL AND ^NRFI21 = NULL AND ^NRFI22 = NULL)
    
            Data Elements:
    
            RP:^NRFI3 = tns:IncomeTax.NonResidentAssessment.Code
    
            RP:^NRFI11 = tns:Income.SalaryOrWages.Amount
    
            RP:^NRFI12 = tns:Remuneration.EmploymentAllowances.Amount
    
            RP:^NRFI13 = tns:Payment.Government.Amount
    
            RP:^NRFI14 = tns:Payment.Taxable.Amount
    
            RP:^NRFI15 = tns:Income.Net.Amount
    
            RP:^NRFI16 = tns:Income.PersonalServicesIncome.Total.Amount
    
            RP:^NRFI17 = tns:Income.Interest.Gross.Amount
    
            RP:^NRFI18 = tns:Income.DividendsTotal.Amount
    
            RP:^NRFI19 = tns:InternationalDealings.ForeignSourceCompanyIncomeOther.Amount
    
            RP:^NRFI20 = tns:Capital.Gains.Total.Amount
    
            RP:^NRFI21 = tns:InternationalDealings.ForeignRent.Amount
    
            RP:^NRFI22 = tns:InternationalDealings.ForeignEmploymentIncomeOther.Amount
            */
            assertion = (report.NRFI3 == @"Comprehensive" && (report.NRFI11 == null && report.NRFI12 == null && report.NRFI13 == null && report.NRFI14 == null && report.NRFI15 == null && report.NRFI16 == null && report.NRFI17 == null && report.NRFI18 == null && report.NRFI19 == null && report.NRFI20 == null && report.NRFI21 == null && report.NRFI22 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100006", Severity = ProcessMessageSeverity.Error,
                    Description = @"At least one income field must be present if the Foreign income assessment method is ""Comprehensive""",
                    Location = "/xbrli:xbrl/tns:IncomeTax.NonResidentAssessment.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100006"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI3", Value = report.NRFI3 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI11", Value = report.NRFI11.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI12", Value = report.NRFI12.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI13", Value = report.NRFI13.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI14", Value = report.NRFI14.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI15", Value = report.NRFI15.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI16", Value = report.NRFI16.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI17", Value = report.NRFI17.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI18", Value = report.NRFI18.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI19", Value = report.NRFI19.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI20", Value = report.NRFI20.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI21", Value = report.NRFI21.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI22", Value = report.NRFI22.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100006
    
            #region VR.ATO.NRFI.100007
    
            /*  VR.ATO.NRFI.100007
            Gross foreign income amount is mandatory if the Foreign income assessment method is "Simple"
    
            Legacy Rule Format:
            IF [NRFI3] = "Simple" AND [NRFI4] = NULL
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^NRFI3 = 'Simple' AND ^NRFI4 = NULL
    
            Data Elements:
    
            RP:^NRFI3 = tns:IncomeTax.NonResidentAssessment.Code
    
            RP:^NRFI4 = tns:InternationalDealings.ForeignIncomeGross.Amount
            */
            assertion = (report.NRFI3 == @"Simple" && report.NRFI4 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100007", Severity = ProcessMessageSeverity.Error,
                    Description = @"Gross foreign income amount must be provided",
                    LongDescription = @"Gross foreign income amount must be present if the Foreign income assessment method provided is ""Simple""",
                    Location = "/xbrli:xbrl/tns:IncomeTax.NonResidentAssessment.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100007"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI3", Value = report.NRFI3 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI4", Value = report.NRFI4.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100007
    
            #region VR.ATO.NRFI.100008
    
            /*  VR.ATO.NRFI.100008
            When the Foreign income assessment method is "Overseas", all foreign tax return details must be provided
    
            Legacy Rule Format:
            IF [NRFI3] = "Overseas" AND ([NRFI5] = NULLORBLANK OR [NRFI6] = NULL OR [NRFI7] = NULL OR [NRFI8] = NULL OR [NRFI9] = NULL OR [NRFI10] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^NRFI3 = 'Overseas' AND (^NRFI5 = BLANK OR ^NRFI6 = NULL OR ^NRFI7 = NULL OR ^NRFI8 = NULL OR ^NRFI9 = NULL OR ^NRFI10 = NULL)
    
            Data Elements:
    
            RP:^NRFI3 = tns:IncomeTax.NonResidentAssessment.Code
    
            RP:^NRFI5 = tns:Identifiers.TaxIdentificationNumber.Identifier
    
            RP:^NRFI6 = tns:Residency.TaxPurposesCountry.Code
    
            RP:^NRFI7 = tns:Report.TargetFinancial.Year
    
            RP:^NRFI8 = tns:Period.Start.Date
    
            RP:^NRFI9 = tns:Period.End.Date
    
            RP:^NRFI10 = tns:InternationalDealings.ForeignEmploymentIncomePaymentSummary.Amount
            */
            assertion = (report.NRFI3 == @"Overseas" && (string.IsNullOrWhiteSpace(report.NRFI5) == true || report.NRFI6 == null || report.NRFI7 == null || report.NRFI8 == null || report.NRFI9 == null || report.NRFI10 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100008", Severity = ProcessMessageSeverity.Error,
                    Description = @"All foreign tax return details must be provided",
                    LongDescription = @"When the Foreign income assessment method is ""Overseas"", all foreign tax return details must be provided",
                    Location = "/xbrli:xbrl/tns:IncomeTax.NonResidentAssessment.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100008"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI3", Value = report.NRFI3 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI5", Value = report.NRFI5 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI6", Value = report.NRFI6 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI7", Value = report.NRFI7.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI8", Value = GetValueOrEmpty(report.NRFI8) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI9", Value = GetValueOrEmpty(report.NRFI9) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI10", Value = report.NRFI10.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100008
    
            #region VR.ATO.NRFI.100011
    
            /*  VR.ATO.NRFI.100011
            The number of Foreign income source country codes must not exceed 10
    
            Legacy Rule Format:
            IF COUNT([NRFI1]) > 10
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^NRFI1) > 10
    
            Data Elements:
    
            RP:^NRFI1 = tns:AddressDetails.Country.Code
            */
            assertion = (Count(report.NRFI1Collection) > 10);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100011", Severity = ProcessMessageSeverity.Error,
                    Description = @"The number of Foreign income source country codes must not exceed 10",
                    Location = "/xbrli:xbrl/tns:IncomeTax.NonResidentAssessment.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100011"} },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100011
    
            #region VR.ATO.NRFI.100012
    
            /*  VR.ATO.NRFI.100012
            Gross foreign income amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI4] <> NULL AND [NRFI4] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI4, 'U', 11, 0)
    
            Data Elements:
    
            RP:^NRFI4 = tns:InternationalDealings.ForeignIncomeGross.Amount
            */
            assertion = NotMonetary(report.NRFI4, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100012", Severity = ProcessMessageSeverity.Error,
                    Description = @"Gross foreign income amount is not in a valid monetary format",
                    LongDescription = @"Gross foreign income amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ForeignIncomeGross.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100012"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI4", Value = report.NRFI4.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100012
    
            #region VR.ATO.NRFI.100013
    
            /*  VR.ATO.NRFI.100013
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character
    
            Legacy Rule Format:
            IF [NRFI5] <> NULLORBLANK AND ANY CHARACTER OF [NRFI5] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," ")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^NRFI5 <> BLANK AND NotCharacterInSet(^NRFI5, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "')
    
            Data Elements:
    
            RP:^NRFI5 = tns:Identifiers.TaxIdentificationNumber.Identifier
            */
            assertion = (string.IsNullOrWhiteSpace(report.NRFI5) != true && !(IsMatch(report.NRFI5, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$",RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100013", Severity = ProcessMessageSeverity.Error,
                    Description = @"Foreign tax return Tax File Number equivalent contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                    Location = "/xbrli:xbrl/tns:Identifiers.TaxIdentificationNumber.Identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100013"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI5", Value = report.NRFI5 });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100013
    
            #region VR.ATO.NRFI.100017
    
            /*  VR.ATO.NRFI.100017
            The Foreign tax return period must overlap with the tax return year
    
            Legacy Rule Format:
            IF ([NRFI8] <> NULL AND [NRFI8] > RP:period.endDate) OR ([NRFI9] <> NULL AND [NRFI9] < RP:period.startDate)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^NRFI8 <> NULL AND ^NRFI8 > ^EndDate) OR (^NRFI9 <> NULL AND ^NRFI9 < ^StartDate1)
    
            Data Elements:
    
            RP:^NRFI8 = tns:Period.Start.Date
    
            RP:^EndDate = RP
    
            RP:^StartDate1 = RP
    
            RP:^NRFI9 = tns:Period.End.Date
            */
            assertion = (report.NRFI8 != null && report.NRFI8.GetValueOrDefault() > report.RPEndDate || report.NRFI9 != null && report.NRFI9.GetValueOrDefault() < report.RPStartDate);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100017", Severity = ProcessMessageSeverity.Error,
                    Description = @"The Foreign tax return period must overlap with the tax return year",
                    Location = "/xbrli:xbrl/tns:Period.Start.Date",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100017"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI8", Value = GetValueOrEmpty(report.NRFI8) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI9", Value = GetValueOrEmpty(report.NRFI9) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100017

            #region VR.ATO.NRFI.100018

            /*  VR.ATO.NRFI.100018
            Foreign tax return period must be exactly one year when the Foreign income assessment method is "Overseas"
    
            Legacy Rule Format:
            IF [NRFI8] <> NULL AND [NRFI9] <> NULL AND [NRFI9] <> ConvertToDate(Day([NRFI8]) - 1, MonthAsInt([NRFI8]), Year([NRFI8]) + 1)
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^NRFI8 <> NULL AND ^NRFI9 <> NULL AND ^NRFI9 <> ConvertToDate(Day(^NRFI8) - 1, MonthAsInt(^NRFI8), Year(^NRFI8) + 1)
    
            Data Elements:
    
            RP:^NRFI9 = tns:Period.End.Date
    
            RP:^NRFI8 = tns:Period.Start.Date
            */
            assertion = VRATONRFI100018(report);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100018", Severity = ProcessMessageSeverity.Error,
                    Description = @"Foreign tax return period must be exactly one year when the Foreign income assessment method is ""Overseas""",
                    Location = "/xbrli:xbrl/tns:Period.End.Date",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100018"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI8", Value = GetValueOrEmpty(report.NRFI8) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI9", Value = GetValueOrEmpty(report.NRFI9) });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100018
    
            #region VR.ATO.NRFI.100019
    
            /*  VR.ATO.NRFI.100019
            Foreign tax return taxable income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI10] <> NULL AND [NRFI10] <> MONETARY(S,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI10, 'S', 11, 0)
    
            Data Elements:
    
            RP:^NRFI10 = tns:InternationalDealings.ForeignEmploymentIncomePaymentSummary.Amount
            */
            assertion = NotMonetary(report.NRFI10, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100019", Severity = ProcessMessageSeverity.Error,
                    Description = @"Foreign tax return taxable income amount is not in a valid monetary format",
                    LongDescription = @"Foreign tax return taxable income may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ForeignEmploymentIncomePaymentSummary.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100019"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI10", Value = report.NRFI10.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100019
    
            #region VR.ATO.NRFI.100020
    
            /*  VR.ATO.NRFI.100020
            Total salary or wages amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI11] <> NULL AND [NRFI11] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI11, 'U', 11, 0)
    
            Data Elements:
    
            RP:^NRFI11 = tns:Income.SalaryOrWages.Amount
            */
            assertion = NotMonetary(report.NRFI11, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100020", Severity = ProcessMessageSeverity.Error,
                    Description = @"Total salary or wages amount is not in a valid monetary format",
                    LongDescription = @"Total salary or wages amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.SalaryOrWages.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100020"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI11", Value = report.NRFI11.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100020
    
            #region VR.ATO.NRFI.100021
    
            /*  VR.ATO.NRFI.100021
            Total allowance amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI12] <> NULL AND [NRFI12] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI12, 'U', 11, 0)
    
            Data Elements:
    
            RP:^NRFI12 = tns:Remuneration.EmploymentAllowances.Amount
            */
            assertion = NotMonetary(report.NRFI12, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100021", Severity = ProcessMessageSeverity.Error,
                    Description = @"Total allowance amount is not in a valid monetary format",
                    LongDescription = @"Total allowance amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Remuneration.EmploymentAllowances.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100021"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI12", Value = report.NRFI12.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100021
    
            #region VR.ATO.NRFI.100022
    
            /*  VR.ATO.NRFI.100022
            Total government allowances amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI13] <> NULL AND [NRFI13] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI13, 'U', 11, 0)
    
            Data Elements:
    
            RP:^NRFI13 = tns:Payment.Government.Amount
            */
            assertion = NotMonetary(report.NRFI13, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100022", Severity = ProcessMessageSeverity.Error,
                    Description = @"Total government allowances amount is not in a valid monetary format",
                    LongDescription = @"Total government allowances amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Payment.Government.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100022"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI13", Value = report.NRFI13.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100022
    
            #region VR.ATO.NRFI.100023
    
            /*  VR.ATO.NRFI.100023
            Total pension amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI14] <> NULL AND [NRFI14] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI14, 'U', 11, 0)
    
            Data Elements:
    
            RP:^NRFI14 = tns:Payment.Taxable.Amount
            */
            assertion = NotMonetary(report.NRFI14, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100023", Severity = ProcessMessageSeverity.Error,
                    Description = @"Total pension amount is not in a valid monetary format",
                    LongDescription = @"Total pension amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Payment.Taxable.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100023"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI14", Value = report.NRFI14.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100023
    
            #region VR.ATO.NRFI.100024
    
            /*  VR.ATO.NRFI.100024
            Net business income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI15] <> NULL AND [NRFI15] <> MONETARY(S,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI15, 'S', 11, 0)
    
            Data Elements:
    
            RP:^NRFI15 = tns:Income.Net.Amount
            */
            assertion = NotMonetary(report.NRFI15, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100024", Severity = ProcessMessageSeverity.Error,
                    Description = @"Net business income amount is not in a valid monetary format",
                    LongDescription = @"Net business income may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.Net.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100024"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI15", Value = report.NRFI15.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100024
    
            #region VR.ATO.NRFI.100025
    
            /*  VR.ATO.NRFI.100025
            Total personal services income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI16] <> NULL AND [NRFI16] <> MONETARY(S,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI16, 'S', 11, 0)
    
            Data Elements:
    
            RP:^NRFI16 = tns:Income.PersonalServicesIncome.Total.Amount
            */
            assertion = NotMonetary(report.NRFI16, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100025", Severity = ProcessMessageSeverity.Error,
                    Description = @"Total personal services income amount is not in a valid monetary format",
                    LongDescription = @"Total personal services income may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.PersonalServicesIncome.Total.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100025"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI16", Value = report.NRFI16.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100025
    
            #region VR.ATO.NRFI.100026
    
            /*  VR.ATO.NRFI.100026
            Total interest amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI17] <> NULL AND [NRFI17] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI17, 'U', 11, 0)
    
            Data Elements:
    
            RP:^NRFI17 = tns:Income.Interest.Gross.Amount
            */
            assertion = NotMonetary(report.NRFI17, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100026", Severity = ProcessMessageSeverity.Error,
                    Description = @"Total interest amount is not in a valid monetary format",
                    LongDescription = @"Total interest amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.Interest.Gross.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100026"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI17", Value = report.NRFI17.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100026
    
            #region VR.ATO.NRFI.100027
    
            /*  VR.ATO.NRFI.100027
            Total dividend amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI18] <> NULL AND [NRFI18] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI18, 'U', 11, 0)
    
            Data Elements:
    
            RP:^NRFI18 = tns:Income.DividendsTotal.Amount
            */
            assertion = NotMonetary(report.NRFI18, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100027", Severity = ProcessMessageSeverity.Error,
                    Description = @"Total dividend amount is not in a valid monetary format",
                    LongDescription = @"Total dividend amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.DividendsTotal.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100027"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI18", Value = report.NRFI18.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100027
    
            #region VR.ATO.NRFI.100028
    
            /*  VR.ATO.NRFI.100028
            Net partnership and trust income amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI19] <> NULL AND [NRFI19] <> MONETARY(S,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI19, 'S', 11, 0)
    
            Data Elements:
    
            RP:^NRFI19 = tns:InternationalDealings.ForeignSourceCompanyIncomeOther.Amount
            */
            assertion = NotMonetary(report.NRFI19, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100028", Severity = ProcessMessageSeverity.Error,
                    Description = @"Net partnership and trust income amount is not in a valid monetary format",
                    LongDescription = @"Net partnership and trust income amount may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ForeignSourceCompanyIncomeOther.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100028"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI19", Value = report.NRFI19.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100028
    
            #region VR.ATO.NRFI.100029
    
            /*  VR.ATO.NRFI.100029
            Net capital gains amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI20] <> NULL AND [NRFI20] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI20, 'U', 11, 0)
    
            Data Elements:
    
            RP:^NRFI20 = tns:Capital.Gains.Total.Amount
            */
            assertion = NotMonetary(report.NRFI20, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100029", Severity = ProcessMessageSeverity.Error,
                    Description = @"Net capital gains amount is not in a valid monetary format",
                    LongDescription = @"Net capital gains amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Capital.Gains.Total.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100029"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI20", Value = report.NRFI20.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100029
    
            #region VR.ATO.NRFI.100030
    
            /*  VR.ATO.NRFI.100030
            Net rent amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI21] <> NULL AND [NRFI21] <> MONETARY(S,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI21, 'S', 11, 0)
    
            Data Elements:
    
            RP:^NRFI21 = tns:InternationalDealings.ForeignRent.Amount
            */
            assertion = NotMonetary(report.NRFI21, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100030", Severity = ProcessMessageSeverity.Error,
                    Description = @"Net rent amount is not in a valid monetary format",
                    LongDescription = @"Net rent amount may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ForeignRent.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100030"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI21", Value = report.NRFI21.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100030
    
            #region VR.ATO.NRFI.100031
    
            /*  VR.ATO.NRFI.100031
            Total other income amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI22] <> NULL AND [NRFI22] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI22, 'U', 11, 0)
    
            Data Elements:
    
            RP:^NRFI22 = tns:InternationalDealings.ForeignEmploymentIncomeOther.Amount
            */
            assertion = NotMonetary(report.NRFI22, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100031", Severity = ProcessMessageSeverity.Error,
                    Description = @"Total other income amount is not in a valid monetary format",
                    LongDescription = @"Total other income amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ForeignEmploymentIncomeOther.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100031"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI22", Value = report.NRFI22.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100031
    
            #region VR.ATO.NRFI.100032
    
            /*  VR.ATO.NRFI.100032
            Total employee work related deduction amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI23] <> NULL AND [NRFI23] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI23, 'U', 11, 0)
    
            Data Elements:
    
            RP:^NRFI23 = tns:Expense.DeductionsTotal.Amount
            */
            assertion = NotMonetary(report.NRFI23, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100032", Severity = ProcessMessageSeverity.Error,
                    Description = @"Total employee work related deduction amount is not in a valid monetary format",
                    LongDescription = @"Total employee work related deduction amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Expense.DeductionsTotal.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100032"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI23", Value = report.NRFI23.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100032
    
            #region VR.ATO.NRFI.100033
    
            /*  VR.ATO.NRFI.100033
            Total depreciation amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI24] <> NULL AND [NRFI24] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI24, 'U', 11, 0)
    
            Data Elements:
    
            RP:^NRFI24 = tns:Expense.DepreciationAllowableDeduction.Amount
            */
            assertion = NotMonetary(report.NRFI24, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100033", Severity = ProcessMessageSeverity.Error,
                    Description = @"Total depreciation amount is not in a valid monetary format",
                    LongDescription = @"Total depreciation amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Expense.DepreciationAllowableDeduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100033"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI24", Value = report.NRFI24.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100033
    
            #region VR.ATO.NRFI.100034
    
            /*  VR.ATO.NRFI.100034
            Total interest and dividend amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI25] <> NULL AND [NRFI25] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI25, 'U', 11, 0)
    
            Data Elements:
    
            RP:^NRFI25 = tns:IncomeTax.Deduction.InterestDividendClaimed.Amount
            */
            assertion = NotMonetary(report.NRFI25, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100034", Severity = ProcessMessageSeverity.Error,
                    Description = @"Total interest and dividend amount is not in a valid monetary format",
                    LongDescription = @"Total interest and dividend amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.InterestDividendClaimed.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100034"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI25", Value = report.NRFI25.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100034
    
            #region VR.ATO.NRFI.100035
    
            /*  VR.ATO.NRFI.100035
            Total undeducted purchase price of a foreign pension amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI26] <> NULL AND [NRFI26] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI26, 'U', 11, 0)
    
            Data Elements:
    
            RP:^NRFI26 = tns:IncomeTax.Deduction.ForeignPensionAnnuityIncomeUndeductedPurchasePrice.Amount
            */
            assertion = NotMonetary(report.NRFI26, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100035", Severity = ProcessMessageSeverity.Error,
                    Description = @"Total undeducted purchase price of a foreign pension amount is not in a valid monetary format",
                    LongDescription = @"Total undeducted purchase price of a foreign pension amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.ForeignPensionAnnuityIncomeUndeductedPurchasePrice.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100035"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI26", Value = report.NRFI26.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100035
    
            #region VR.ATO.NRFI.100036
    
            /*  VR.ATO.NRFI.100036
            Total personal super contributions for business has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI27] <> NULL AND [NRFI27] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI27, 'U', 11, 0)
    
            Data Elements:
    
            RP:^NRFI27 = tns:IncomeTax.Deduction.SuperannuationContribution.Amount
            */
            assertion = NotMonetary(report.NRFI27, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100036", Severity = ProcessMessageSeverity.Error,
                    Description = @"Total personal super contributions for business amount is not in a valid monetary format",
                    LongDescription = @"Total personal super contributions for business must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.SuperannuationContribution.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100036"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI27", Value = report.NRFI27.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100036
    
            #region VR.ATO.NRFI.100037
    
            /*  VR.ATO.NRFI.100037
            Total other deduction amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI28] <> NULL AND [NRFI28] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI28, 'U', 11, 0)
    
            Data Elements:
    
            RP:^NRFI28 = tns:Expense.DeductibleOtherTotal.Amount
            */
            assertion = NotMonetary(report.NRFI28, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100037", Severity = ProcessMessageSeverity.Error,
                    Description = @"Total other deduction amount is not in a valid monetary format",
                    LongDescription = @"Total other deduction amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Expense.DeductibleOtherTotal.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100037"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI28", Value = report.NRFI28.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100037
    
            #region VR.ATO.NRFI.100038
    
            /*  VR.ATO.NRFI.100038
            Prior year tax losses amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [NRFI32] <> NULL AND [NRFI32] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^NRFI32, 'U', 11, 0)
    
            Data Elements:
    
            RP:^NRFI32 = tns:Tax.Losses.Deducted.Amount
            */
            assertion = NotMonetary(report.NRFI32, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100038", Severity = ProcessMessageSeverity.Error,
                    Description = @"Prior year tax losses amount is not in a valid monetary format",
                    LongDescription = @"Prior year tax losses amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.Deducted.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100038"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI32", Value = report.NRFI32.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100038
    
            #region VR.ATO.NRFI.100039
    
            /*  VR.ATO.NRFI.100039
            Foreign taxation return country code must not be "Australia", "Christmas Island", "Norfolk Island" or "Cocos (Keeling) Islands"
    
            Legacy Rule Format:
            IF [NRFI6] = SET("au","cc","cx","nf")
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            InSet(^NRFI6, '"au","cc","cx","nf"')
    
            Data Elements:
    
            RP:^NRFI6 = tns:Residency.TaxPurposesCountry.Code
            */
            assertion = IsMatch(report.NRFI6, @"^(au|cc|cx|nf)$");
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100039", Severity = ProcessMessageSeverity.Error,
                    Description = @"Foreign taxation return country code must not be ""Australia"", ""Christmas Island"", ""Norfolk Island"" or ""Cocos (Keeling) Islands""",
                    Location = "/xbrli:xbrl/tns:Residency.TaxPurposesCountry.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100039"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI6", Value = report.NRFI6 });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100039
    
            #region VR.ATO.NRFI.100040
    
            /*  VR.ATO.NRFI.100040
            Foreign tax return Tax File Number equivalent has a maximum field length of 20
    
            Legacy Rule Format:
            IF [NRFI5] <> NULLORBLANK AND LENGTH([NRFI5]) > 20
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^NRFI5) > 20
    
            Data Elements:
    
            RP:^NRFI5 = tns:Identifiers.TaxIdentificationNumber.Identifier
            */
            assertion = (Length(report.NRFI5) > 20);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100040", Severity = ProcessMessageSeverity.Error,
                    Description = @"Foreign tax return Tax File Number equivalent must not exceed 20 characters",
                    LongDescription = @"For Foreign tax return Tax File Number equivalent, the maximum allowable characters for this form is 20",
                    Location = "/xbrli:xbrl/tns:Identifiers.TaxIdentificationNumber.Identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100040"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI5", Value = report.NRFI5 });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100040
    
            #region VR.ATO.NRFI.100041
    
            /*  VR.ATO.NRFI.100041
            When the Foreign income assessment method is "Simple", overseas assessed and comprehensive assessment details must not be provided
    
            Legacy Rule Format:
            IF [NRFI3] =  "Simple" AND ([NRFI5] <> NULLORBLANK OR [NRFI6] <> NULL OR [NRFI7] <> NULL OR [NRFI8] <> NULL OR [NRFI9] <> NULL OR [NRFI10] <> NULL OR [NRFI11] <> NULL OR [NRFI12] <> NULL OR [NRFI13] <> NULL OR [NRFI14] <> NULL OR [NRFI15] <> NULL OR [NRFI16] <> NULL OR [NRFI17] <> NULL OR [NRFI18] <> NULL OR [NRFI19] <> NULL OR [NRFI20] <> NULL OR [NRFI21] <> NULL OR [NRFI22] <> NULL OR [NRFI23] <> NULL OR [NRFI24] <> NULL OR [NRFI25] <> NULL OR [NRFI26] <> NULL OR [NRFI27] <> NULL OR [NRFI28] <> NULL OR [NRFI32] <> NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^NRFI3 = 'Simple' AND (^NRFI5 <> BLANK OR ^NRFI6 <> NULL OR ^NRFI7 <> NULL OR ^NRFI8 <> NULL OR ^NRFI9 <> NULL OR ^NRFI10 <> NULL OR ^NRFI11 <> NULL OR ^NRFI12 <> NULL OR ^NRFI13 <> NULL OR ^NRFI14 <> NULL OR ^NRFI15 <> NULL OR ^NRFI16 <> NULL OR ^NRFI17 <> NULL OR ^NRFI18 <> NULL OR ^NRFI19 <> NULL OR ^NRFI20 <> NULL OR ^NRFI21 <> NULL OR ^NRFI22 <> NULL OR ^NRFI23 <> NULL OR ^NRFI24 <> NULL OR ^NRFI25 <> NULL OR ^NRFI26 <> NULL OR ^NRFI27 <> NULL OR ^NRFI28 <> NULL OR ^NRFI32 <> NULL)
    
            Data Elements:
    
            RP:^NRFI3 = tns:IncomeTax.NonResidentAssessment.Code
    
            RP:^NRFI5 = tns:Identifiers.TaxIdentificationNumber.Identifier
    
            RP:^NRFI6 = tns:Residency.TaxPurposesCountry.Code
    
            RP:^NRFI7 = tns:Report.TargetFinancial.Year
    
            RP:^NRFI8 = tns:Period.Start.Date
    
            RP:^NRFI9 = tns:Period.End.Date
    
            RP:^NRFI10 = tns:InternationalDealings.ForeignEmploymentIncomePaymentSummary.Amount
    
            RP:^NRFI11 = tns:Income.SalaryOrWages.Amount
    
            RP:^NRFI12 = tns:Remuneration.EmploymentAllowances.Amount
    
            RP:^NRFI13 = tns:Payment.Government.Amount
    
            RP:^NRFI14 = tns:Payment.Taxable.Amount
    
            RP:^NRFI15 = tns:Income.Net.Amount
    
            RP:^NRFI16 = tns:Income.PersonalServicesIncome.Total.Amount
    
            RP:^NRFI17 = tns:Income.Interest.Gross.Amount
    
            RP:^NRFI18 = tns:Income.DividendsTotal.Amount
    
            RP:^NRFI19 = tns:InternationalDealings.ForeignSourceCompanyIncomeOther.Amount
    
            RP:^NRFI20 = tns:Capital.Gains.Total.Amount
    
            RP:^NRFI21 = tns:InternationalDealings.ForeignRent.Amount
    
            RP:^NRFI22 = tns:InternationalDealings.ForeignEmploymentIncomeOther.Amount
    
            RP:^NRFI23 = tns:Expense.DeductionsTotal.Amount
    
            RP:^NRFI24 = tns:Expense.DepreciationAllowableDeduction.Amount
    
            RP:^NRFI25 = tns:IncomeTax.Deduction.InterestDividendClaimed.Amount
    
            RP:^NRFI26 = tns:IncomeTax.Deduction.ForeignPensionAnnuityIncomeUndeductedPurchasePrice.Amount
    
            RP:^NRFI27 = tns:IncomeTax.Deduction.SuperannuationContribution.Amount
    
            RP:^NRFI28 = tns:Expense.DeductibleOtherTotal.Amount
    
            RP:^NRFI32 = tns:Tax.Losses.Deducted.Amount
            */
            assertion = (report.NRFI3 == @"Simple" && (string.IsNullOrWhiteSpace(report.NRFI5) != true || report.NRFI6 != null || report.NRFI7 != null || report.NRFI8 != null || report.NRFI9 != null || report.NRFI10 != null || report.NRFI11 != null || report.NRFI12 != null || report.NRFI13 != null || report.NRFI14 != null || report.NRFI15 != null || report.NRFI16 != null || report.NRFI17 != null || report.NRFI18 != null || report.NRFI19 != null || report.NRFI20 != null || report.NRFI21 != null || report.NRFI22 != null || report.NRFI23 != null || report.NRFI24 != null || report.NRFI25 != null || report.NRFI26 != null || report.NRFI27 != null || report.NRFI28 != null || report.NRFI32 != null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100041", Severity = ProcessMessageSeverity.Error,
                    Description = @"Incorrect Foreign income assessment method details provided",
                    LongDescription = @"When the Foreign income assessment method is ""Simple"", overseas assessed and comprehensive assessment details must not be provided",
                    Location = "/xbrli:xbrl/tns:IncomeTax.NonResidentAssessment.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100041"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI3", Value = report.NRFI3 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI5", Value = report.NRFI5 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI6", Value = report.NRFI6 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI7", Value = report.NRFI7.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI8", Value = GetValueOrEmpty(report.NRFI8) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI9", Value = GetValueOrEmpty(report.NRFI9) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI10", Value = report.NRFI10.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI11", Value = report.NRFI11.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI12", Value = report.NRFI12.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI13", Value = report.NRFI13.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI14", Value = report.NRFI14.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI15", Value = report.NRFI15.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI16", Value = report.NRFI16.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI17", Value = report.NRFI17.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI18", Value = report.NRFI18.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI19", Value = report.NRFI19.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI20", Value = report.NRFI20.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI21", Value = report.NRFI21.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI22", Value = report.NRFI22.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI23", Value = report.NRFI23.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI24", Value = report.NRFI24.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI25", Value = report.NRFI25.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI26", Value = report.NRFI26.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI27", Value = report.NRFI27.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI28", Value = report.NRFI28.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI32", Value = report.NRFI32.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100041
    
            #region VR.ATO.NRFI.100042
    
            /*  VR.ATO.NRFI.100042
            When the Foreign income assessment method is "Overseas", simple self assessment and comprehensive assessment details must not be provided
    
            Legacy Rule Format:
            IF [NRFI3] =  "Overseas" AND ([NRFI4] <> NULL OR [NRFI11] <> NULL OR [NRFI12] <> NULL OR [NRFI13] <> NULL OR [NRFI14] <> NULL OR [NRFI15] <> NULL OR [NRFI16] <> NULL OR [NRFI17] <> NULL OR [NRFI18] <> NULL OR [NRFI19] <> NULL OR [NRFI20] <> NULL OR [NRFI21] <> NULL OR [NRFI22] <> NULL OR [NRFI23] <> NULL OR [NRFI24] <> NULL OR [NRFI25] <> NULL OR [NRFI26] <> NULL OR [NRFI27] <> NULL OR [NRFI28] <> NULL OR [NRFI32] <> NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^NRFI3 = 'Overseas' AND (^NRFI4 <> NULL OR ^NRFI11 <> NULL OR ^NRFI12 <> NULL OR ^NRFI13 <> NULL OR ^NRFI14 <> NULL OR ^NRFI15 <> NULL OR ^NRFI16 <> NULL OR ^NRFI17 <> NULL OR ^NRFI18 <> NULL OR ^NRFI19 <> NULL OR ^NRFI20 <> NULL OR ^NRFI21 <> NULL OR ^NRFI22 <> NULL OR ^NRFI23 <> NULL OR ^NRFI24 <> NULL OR ^NRFI25 <> NULL OR ^NRFI26 <> NULL OR ^NRFI27 <> NULL OR ^NRFI28 <> NULL OR ^NRFI32 <> NULL)
    
            Data Elements:
    
            RP:^NRFI3 = tns:IncomeTax.NonResidentAssessment.Code
    
            RP:^NRFI4 = tns:InternationalDealings.ForeignIncomeGross.Amount
    
            RP:^NRFI11 = tns:Income.SalaryOrWages.Amount
    
            RP:^NRFI12 = tns:Remuneration.EmploymentAllowances.Amount
    
            RP:^NRFI13 = tns:Payment.Government.Amount
    
            RP:^NRFI14 = tns:Payment.Taxable.Amount
    
            RP:^NRFI15 = tns:Income.Net.Amount
    
            RP:^NRFI16 = tns:Income.PersonalServicesIncome.Total.Amount
    
            RP:^NRFI17 = tns:Income.Interest.Gross.Amount
    
            RP:^NRFI18 = tns:Income.DividendsTotal.Amount
    
            RP:^NRFI19 = tns:InternationalDealings.ForeignSourceCompanyIncomeOther.Amount
    
            RP:^NRFI20 = tns:Capital.Gains.Total.Amount
    
            RP:^NRFI21 = tns:InternationalDealings.ForeignRent.Amount
    
            RP:^NRFI22 = tns:InternationalDealings.ForeignEmploymentIncomeOther.Amount
    
            RP:^NRFI23 = tns:Expense.DeductionsTotal.Amount
    
            RP:^NRFI24 = tns:Expense.DepreciationAllowableDeduction.Amount
    
            RP:^NRFI25 = tns:IncomeTax.Deduction.InterestDividendClaimed.Amount
    
            RP:^NRFI26 = tns:IncomeTax.Deduction.ForeignPensionAnnuityIncomeUndeductedPurchasePrice.Amount
    
            RP:^NRFI27 = tns:IncomeTax.Deduction.SuperannuationContribution.Amount
    
            RP:^NRFI28 = tns:Expense.DeductibleOtherTotal.Amount
    
            RP:^NRFI32 = tns:Tax.Losses.Deducted.Amount
            */
            assertion = (report.NRFI3 == @"Overseas" && (report.NRFI4 != null || report.NRFI11 != null || report.NRFI12 != null || report.NRFI13 != null || report.NRFI14 != null || report.NRFI15 != null || report.NRFI16 != null || report.NRFI17 != null || report.NRFI18 != null || report.NRFI19 != null || report.NRFI20 != null || report.NRFI21 != null || report.NRFI22 != null || report.NRFI23 != null || report.NRFI24 != null || report.NRFI25 != null || report.NRFI26 != null || report.NRFI27 != null || report.NRFI28 != null || report.NRFI32 != null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100042", Severity = ProcessMessageSeverity.Error,
                    Description = @"Incorrect Foreign income assessment method details provided",
                    LongDescription = @"When the Foreign income assessment method is ""Overseas"", simple self assessment and comprehensive assessment details must not be provided",
                    Location = "/xbrli:xbrl/tns:IncomeTax.NonResidentAssessment.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100042"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI3", Value = report.NRFI3 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI4", Value = report.NRFI4.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI11", Value = report.NRFI11.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI12", Value = report.NRFI12.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI13", Value = report.NRFI13.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI14", Value = report.NRFI14.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI15", Value = report.NRFI15.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI16", Value = report.NRFI16.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI17", Value = report.NRFI17.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI18", Value = report.NRFI18.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI19", Value = report.NRFI19.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI20", Value = report.NRFI20.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI21", Value = report.NRFI21.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI22", Value = report.NRFI22.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI23", Value = report.NRFI23.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI24", Value = report.NRFI24.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI25", Value = report.NRFI25.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI26", Value = report.NRFI26.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI27", Value = report.NRFI27.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI28", Value = report.NRFI28.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI32", Value = report.NRFI32.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100042
    
            #region VR.ATO.NRFI.100043
    
            /*  VR.ATO.NRFI.100043
            When the Foreign income assessment method is "Comprehensive", simple self assessment and overseas assessed details must not be provided
    
            Legacy Rule Format:
            IF [NRFI3] =  "Comprehensive" AND ([NRFI4] <> NULL OR [NRFI5] <> NULLORBLANK OR [NRFI6] <> NULL OR [NRFI7] <> NULL OR [NRFI8] <> NULL OR [NRFI9] <> NULL OR [NRFI10] <> NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^NRFI3 = 'Comprehensive' AND (^NRFI4 <> NULL OR ^NRFI5 <> BLANK OR ^NRFI6 <> NULL OR ^NRFI7 <> NULL OR ^NRFI8 <> NULL OR ^NRFI9 <> NULL OR ^NRFI10 <> NULL)
    
            Data Elements:
    
            RP:^NRFI3 = tns:IncomeTax.NonResidentAssessment.Code
    
            RP:^NRFI4 = tns:InternationalDealings.ForeignIncomeGross.Amount
    
            RP:^NRFI5 = tns:Identifiers.TaxIdentificationNumber.Identifier
    
            RP:^NRFI6 = tns:Residency.TaxPurposesCountry.Code
    
            RP:^NRFI7 = tns:Report.TargetFinancial.Year
    
            RP:^NRFI8 = tns:Period.Start.Date
    
            RP:^NRFI9 = tns:Period.End.Date
    
            RP:^NRFI10 = tns:InternationalDealings.ForeignEmploymentIncomePaymentSummary.Amount
            */
            assertion = (report.NRFI3 == @"Comprehensive" && (report.NRFI4 != null || string.IsNullOrWhiteSpace(report.NRFI5) != true || report.NRFI6 != null || report.NRFI7 != null || report.NRFI8 != null || report.NRFI9 != null || report.NRFI10 != null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100043", Severity = ProcessMessageSeverity.Error,
                    Description = @"Incorrect Foreign income assessment method details provided",
                    LongDescription = @"When the Foreign income assessment method is ""Comprehensive"", simple self assessment and overseas assessed details must not be provided",
                    Location = "/xbrli:xbrl/tns:IncomeTax.NonResidentAssessment.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100043"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI3", Value = report.NRFI3 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI4", Value = report.NRFI4.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI5", Value = report.NRFI5 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI6", Value = report.NRFI6 });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI7", Value = report.NRFI7.GetValueOrDefault().ToString() });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI8", Value = GetValueOrEmpty(report.NRFI8) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI9", Value = GetValueOrEmpty(report.NRFI9) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI10", Value = report.NRFI10.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100043
    
            #region VR.ATO.NRFI.100044
    
            /*  VR.ATO.NRFI.100044
            Foreign occupation description is mandatory
    
            Legacy Rule Format:
            IF [NRFI33] = NULLORBLANK
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^NRFI33 = BLANK
    
            Data Elements:
    
            RP:^NRFI33 = tns:PersonDemographicDetails.Occupation.Description
            */
            assertion = (string.IsNullOrWhiteSpace(report.NRFI33) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100044", Severity = ProcessMessageSeverity.Error,
                    Description = @"Foreign occupation description must be present",
                    LongDescription = @"Foreign occupation description must be present. Where the individual does not have an occupation, or a relevant occupation is not available, enter 'Occupation not listed'.",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.Occupation.Description",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100044"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI33", Value = report.NRFI33 });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100044
    
            #region VR.ATO.NRFI.100045
    
            /*  VR.ATO.NRFI.100045
            Foreign occupation description has a maximum length of 100
    
            Legacy Rule Format:
            IF LENGTH([NRFI33]) > 100
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^NRFI33) > 100
    
            Data Elements:
    
            RP:^NRFI33 = tns:PersonDemographicDetails.Occupation.Description
            */
            assertion = (Length(report.NRFI33) > 100);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100045", Severity = ProcessMessageSeverity.Error,
                    Description = @"Foreign occupation description must not exceed 100 characters",
                    LongDescription = @"For Foreign occupation description, the maximum allowable characters for this form is 100",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.Occupation.Description",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100045"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI33", Value = report.NRFI33 });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100045
    
            #region VR.ATO.NRFI.100046
    
            /*  VR.ATO.NRFI.100046
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character
    
            Legacy Rule Format:
            IF ([NRFI33] <> NULLORBLANK) AND (ANY CHARACTER OF [NRFI33] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^NRFI33 <> BLANK) AND (NotCharacterInSet(^NRFI33, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            RP:^NRFI33 = tns:PersonDemographicDetails.Occupation.Description
            */
            assertion = (string.IsNullOrWhiteSpace(report.NRFI33) != true && !(IsMatch(report.NRFI33, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$",RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.NRFI.100046", Severity = ProcessMessageSeverity.Error,
                    Description = @"Foreign occupation description contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.Occupation.Description",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.NRFI.100046"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "NRFI33", Value = report.NRFI33 });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.NRFI.100046

            foreach (ProcessMessageDocument currentProcessMessage in response)
            {
                if (currentProcessMessage.Parameters != null)
                {
                    foreach (ProcessMessageParameter currentParameter in currentProcessMessage.Parameters)
                    {
                        if (string.IsNullOrEmpty(currentParameter.Name))
                        {
                            currentParameter.Name = _emptyParameterValue;
                        }

                        if (currentParameter.Name.Length > _maxParameterNameLength)
                        {
                            currentParameter.Name = currentParameter.Name.Substring(0, _maxParameterNameLength - 1);
                        }

                        if (string.IsNullOrEmpty(currentParameter.Value))
                        {
                            currentParameter.Value = _emptyParameterValue;
                        }

                        if (currentParameter.Value.Length > _maxParameterValueLength)
                        {
                            currentParameter.Value = currentParameter.Value.Substring(0, _maxParameterValueLength - 1);
                        }
                    }
                }
            }

            return response;
        }


    }
} 
